##################
# Primary Clocks #
##################

# Constrained to 148.5 MHz (1080p60 video resolution)
create_clock -period 6.667 -name video_clk -waveform {0.000 3.333} [get_nets */hdmi_clock/axi_clkgen_0/clk_0]

# Single-ended input clock from HDMI input
# Constrained to 148.5MHz (1080p60 video resolution)
create_clock -period 6.734 -name hdmii_clk [get_ports fmc_hdmii_clk]

####################
# Generated Clocks #
####################

# Rename auto-generated clocks from clk_wiz_1
# Axi-lite clock 50MHz
create_generated_clock -name clk50 [get_pins */clk_wiz_1/inst/mmcm_adv_inst/CLKOUT0]
# AXI Stream and MemoryMap clock 150Mhz
create_generated_clock -name clk150 [get_pins */clk_wiz_1/inst/mmcm_adv_inst/CLKOUT1]

# PYTHON internal clock 108Mhz
#create_generated_clock -name clk108 [get_clocks clk_out1_fmchc_top_clk_wiz_108mhz_0]

# PYTHON external clock 270Mhz
create_clock -period 3.703 -name vita_ser_clk [get_ports IO_PYTHON_CAM_clk_out_p]

################
# Clock Groups #
################

# There is no defined phase relationship, hence they are treated as asynchronous
set_clock_groups -asynchronous -group [get_clocks clk_fpga_0] \
                               -group [get_clocks clk_fpga_1] \
                               -group clk50 \
                               -group clk150 \
                               -group hdmii_clk \
                               -group [get_clocks video_clk] \
                               -group [get_clocks clk_out1_fmchc_*_clk_wiz_108mhz_0] \
                               -group [get_clocks CLKDIV_c_0] \
                               -group [get_clocks vita_clk_div4_l_n_4]

                               
set_input_delay -clock [get_clocks hdmii_clk] -clock_fall -min -add_delay 0.500 [get_ports {fmc_hdmii_data[*]}]
set_input_delay -clock [get_clocks hdmii_clk] -clock_fall -max -add_delay 1.300 [get_ports {fmc_hdmii_data[*]}]
