-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2015.4
-- Copyright (C) 2015 Xilinx Inc. All rights reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity image_filter is
generic (
    C_S_AXI_CONTROL_BUS_ADDR_WIDTH : INTEGER := 8;
    C_S_AXI_CONTROL_BUS_DATA_WIDTH : INTEGER := 32 );
port (
    s_axi_CONTROL_BUS_AWVALID : IN STD_LOGIC;
    s_axi_CONTROL_BUS_AWREADY : OUT STD_LOGIC;
    s_axi_CONTROL_BUS_AWADDR : IN STD_LOGIC_VECTOR (C_S_AXI_CONTROL_BUS_ADDR_WIDTH-1 downto 0);
    s_axi_CONTROL_BUS_WVALID : IN STD_LOGIC;
    s_axi_CONTROL_BUS_WREADY : OUT STD_LOGIC;
    s_axi_CONTROL_BUS_WDATA : IN STD_LOGIC_VECTOR (C_S_AXI_CONTROL_BUS_DATA_WIDTH-1 downto 0);
    s_axi_CONTROL_BUS_WSTRB : IN STD_LOGIC_VECTOR (C_S_AXI_CONTROL_BUS_DATA_WIDTH/8-1 downto 0);
    s_axi_CONTROL_BUS_ARVALID : IN STD_LOGIC;
    s_axi_CONTROL_BUS_ARREADY : OUT STD_LOGIC;
    s_axi_CONTROL_BUS_ARADDR : IN STD_LOGIC_VECTOR (C_S_AXI_CONTROL_BUS_ADDR_WIDTH-1 downto 0);
    s_axi_CONTROL_BUS_RVALID : OUT STD_LOGIC;
    s_axi_CONTROL_BUS_RREADY : IN STD_LOGIC;
    s_axi_CONTROL_BUS_RDATA : OUT STD_LOGIC_VECTOR (C_S_AXI_CONTROL_BUS_DATA_WIDTH-1 downto 0);
    s_axi_CONTROL_BUS_RRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
    s_axi_CONTROL_BUS_BVALID : OUT STD_LOGIC;
    s_axi_CONTROL_BUS_BREADY : IN STD_LOGIC;
    s_axi_CONTROL_BUS_BRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
    ap_clk : IN STD_LOGIC;
    ap_rst_n : IN STD_LOGIC;
    interrupt : OUT STD_LOGIC;
    axilite_clk : IN STD_LOGIC;
    ap_rst_n_axilite_clk : IN STD_LOGIC;
    video_in_TDATA : IN STD_LOGIC_VECTOR (15 downto 0);
    video_in_TKEEP : IN STD_LOGIC_VECTOR (1 downto 0);
    video_in_TSTRB : IN STD_LOGIC_VECTOR (1 downto 0);
    video_in_TUSER : IN STD_LOGIC_VECTOR (0 downto 0);
    video_in_TLAST : IN STD_LOGIC_VECTOR (0 downto 0);
    video_in_TID : IN STD_LOGIC_VECTOR (0 downto 0);
    video_in_TDEST : IN STD_LOGIC_VECTOR (0 downto 0);
    video_out_TDATA : OUT STD_LOGIC_VECTOR (15 downto 0);
    video_out_TKEEP : OUT STD_LOGIC_VECTOR (1 downto 0);
    video_out_TSTRB : OUT STD_LOGIC_VECTOR (1 downto 0);
    video_out_TUSER : OUT STD_LOGIC_VECTOR (0 downto 0);
    video_out_TLAST : OUT STD_LOGIC_VECTOR (0 downto 0);
    video_out_TID : OUT STD_LOGIC_VECTOR (0 downto 0);
    video_out_TDEST : OUT STD_LOGIC_VECTOR (0 downto 0);
    video_in_TVALID : IN STD_LOGIC;
    video_in_TREADY : OUT STD_LOGIC;
    video_out_TVALID : OUT STD_LOGIC;
    video_out_TREADY : IN STD_LOGIC );
end;


architecture behav of image_filter is 
    attribute CORE_GENERATION_INFO : STRING;
    attribute CORE_GENERATION_INFO of behav : architecture is
    "image_filter,hls_ip_2015_4,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020clg484-1,HLS_INPUT_CLOCK=5.000000,HLS_INPUT_ARCH=dataflow,HLS_SYN_CLOCK=4.881000,HLS_SYN_LAT=-1,HLS_SYN_TPT=-1,HLS_SYN_MEM=3,HLS_SYN_DSP=17,HLS_SYN_FF=2478,HLS_SYN_LUT=3483}";
    constant C_S_AXI_DATA_WIDTH : INTEGER range 63 downto 0 := 20;
    constant C_S_AXI_WSTRB_WIDTH : INTEGER range 63 downto 0 := 4;
    constant C_S_AXI_ADDR_WIDTH : INTEGER range 63 downto 0 := 20;
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_lv16_0 : STD_LOGIC_VECTOR (15 downto 0) := "0000000000000000";
    constant ap_const_lv2_0 : STD_LOGIC_VECTOR (1 downto 0) := "00";
    constant ap_const_lv1_0 : STD_LOGIC_VECTOR (0 downto 0) := "0";
    constant ap_true : BOOLEAN := true;
    constant ap_const_logic_0 : STD_LOGIC := '0';

    signal ap_rst_n_inv : STD_LOGIC;
    signal image_filter_CONTROL_BUS_s_axi_U_ap_dummy_ce : STD_LOGIC;
    signal ap_start : STD_LOGIC;
    signal ap_ready : STD_LOGIC;
    signal ap_done : STD_LOGIC;
    signal ap_idle : STD_LOGIC;
    signal rows : STD_LOGIC_VECTOR (31 downto 0);
    signal cols : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal c_high_thresh : STD_LOGIC_VECTOR (31 downto 0);
    signal c_low_thresh : STD_LOGIC_VECTOR (31 downto 0);
    signal c_invert : STD_LOGIC_VECTOR (31 downto 0);
    signal ap_rst_n_axilite_clk_inv : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_start : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_done : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_continue : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_idle : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_ready : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_rows : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_cols : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_c_invert : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2 : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_rows_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_rows_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_rows_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_cols_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_cols_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_cols_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_din : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_din : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_din : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_full_n : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_write : STD_LOGIC;
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_return_0 : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_Block_Mat_exit45_proc42_U0_ap_return_1 : STD_LOGIC_VECTOR (11 downto 0);
    signal ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_rows_V_channel : STD_LOGIC;
    signal img_0_rows_V_channel_full_n : STD_LOGIC;
    signal ap_reg_ready_img_0_rows_V_channel_full_n : STD_LOGIC := '0';
    signal ap_sig_ready_img_0_rows_V_channel_full_n : STD_LOGIC;
    signal ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_cols_V_channel : STD_LOGIC;
    signal img_0_cols_V_channel_full_n : STD_LOGIC;
    signal ap_reg_ready_img_0_cols_V_channel_full_n : STD_LOGIC := '0';
    signal ap_sig_ready_img_0_cols_V_channel_full_n : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_ap_start : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_ap_done : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_ap_continue : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_ap_idle : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_ap_ready : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_video_in_TDATA : STD_LOGIC_VECTOR (15 downto 0);
    signal image_filter_AXIvideo2Mat_U0_video_in_TVALID : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_video_in_TREADY : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_video_in_TKEEP : STD_LOGIC_VECTOR (1 downto 0);
    signal image_filter_AXIvideo2Mat_U0_video_in_TSTRB : STD_LOGIC_VECTOR (1 downto 0);
    signal image_filter_AXIvideo2Mat_U0_video_in_TUSER : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_AXIvideo2Mat_U0_video_in_TLAST : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_AXIvideo2Mat_U0_video_in_TID : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_AXIvideo2Mat_U0_video_in_TDEST : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_AXIvideo2Mat_U0_img_rows_V_read : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_AXIvideo2Mat_U0_img_cols_V_read : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_full_n : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_write : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_full_n : STD_LOGIC;
    signal image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_write : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_ap_start : STD_LOGIC := '0';
    signal image_filter_sobel_filter_core_U0_ap_done : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_ap_continue : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_ap_idle : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_ap_ready : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_src_data_stream_0_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_sobel_filter_core_U0_src_data_stream_0_V_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_src_data_stream_0_V_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_src_data_stream_1_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_sobel_filter_core_U0_src_data_stream_1_V_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_src_data_stream_1_V_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_dst_data_stream_0_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_sobel_filter_core_U0_dst_data_stream_0_V_full_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_dst_data_stream_0_V_write : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_dst_data_stream_1_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_sobel_filter_core_U0_dst_data_stream_1_V_full_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_dst_data_stream_1_V_write : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_rows_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_rows_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_rows_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_cols_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_cols_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_cols_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR0C0_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR0C0_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR0C0_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR0C1_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR0C1_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR0C1_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR0C2_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR0C2_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR0C2_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR1C0_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR1C0_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR1C0_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR1C1_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR1C1_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR1C1_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR1C2_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR1C2_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR1C2_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR2C0_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR2C0_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR2C0_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR2C1_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR2C1_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR2C1_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR2C2_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_XR2C2_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_XR2C2_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR0C0_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR0C0_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR0C0_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR0C1_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR0C1_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR0C1_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR0C2_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR0C2_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR0C2_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR1C0_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR1C0_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR1C0_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR1C1_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR1C1_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR1C1_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR1C2_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR1C2_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR1C2_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR2C0_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR2C0_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR2C0_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR2C1_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_C_YR2C1_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_C_YR2C1_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_c_high_thresh_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_c_high_thresh_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_c_high_thresh_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_c_low_thresh_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_c_low_thresh_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_c_low_thresh_read : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_c_invert_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal image_filter_sobel_filter_core_U0_c_invert_empty_n : STD_LOGIC;
    signal image_filter_sobel_filter_core_U0_c_invert_read : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_ap_start : STD_LOGIC := '0';
    signal image_filter_Mat2AXIvideo_U0_ap_done : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_ap_continue : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_ap_idle : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_ap_ready : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_rows_V_dout : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_Mat2AXIvideo_U0_img_rows_V_empty_n : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_rows_V_read : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_cols_V_dout : STD_LOGIC_VECTOR (11 downto 0);
    signal image_filter_Mat2AXIvideo_U0_img_cols_V_empty_n : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_cols_V_read : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_empty_n : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_read : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_empty_n : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_read : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_video_out_TDATA : STD_LOGIC_VECTOR (15 downto 0);
    signal image_filter_Mat2AXIvideo_U0_video_out_TVALID : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_video_out_TREADY : STD_LOGIC;
    signal image_filter_Mat2AXIvideo_U0_video_out_TKEEP : STD_LOGIC_VECTOR (1 downto 0);
    signal image_filter_Mat2AXIvideo_U0_video_out_TSTRB : STD_LOGIC_VECTOR (1 downto 0);
    signal image_filter_Mat2AXIvideo_U0_video_out_TUSER : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_Mat2AXIvideo_U0_video_out_TLAST : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_Mat2AXIvideo_U0_video_out_TID : STD_LOGIC_VECTOR (0 downto 0);
    signal image_filter_Mat2AXIvideo_U0_video_out_TDEST : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_sig_hs_continue : STD_LOGIC;
    signal rows_channel_U_ap_dummy_ce : STD_LOGIC;
    signal rows_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal rows_channel_full_n : STD_LOGIC;
    signal rows_channel_write : STD_LOGIC;
    signal rows_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal rows_channel_empty_n : STD_LOGIC;
    signal rows_channel_read : STD_LOGIC;
    signal cols_channel_U_ap_dummy_ce : STD_LOGIC;
    signal cols_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal cols_channel_full_n : STD_LOGIC;
    signal cols_channel_write : STD_LOGIC;
    signal cols_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal cols_channel_empty_n : STD_LOGIC;
    signal cols_channel_read : STD_LOGIC;
    signal img_1_rows_V_channel_U_ap_dummy_ce : STD_LOGIC;
    signal img_1_rows_V_channel_din : STD_LOGIC_VECTOR (11 downto 0);
    signal img_1_rows_V_channel_full_n : STD_LOGIC;
    signal img_1_rows_V_channel_write : STD_LOGIC;
    signal img_1_rows_V_channel_dout : STD_LOGIC_VECTOR (11 downto 0);
    signal img_1_rows_V_channel_empty_n : STD_LOGIC;
    signal img_1_rows_V_channel_read : STD_LOGIC;
    signal img_1_cols_V_channel_U_ap_dummy_ce : STD_LOGIC;
    signal img_1_cols_V_channel_din : STD_LOGIC_VECTOR (11 downto 0);
    signal img_1_cols_V_channel_full_n : STD_LOGIC;
    signal img_1_cols_V_channel_write : STD_LOGIC;
    signal img_1_cols_V_channel_dout : STD_LOGIC_VECTOR (11 downto 0);
    signal img_1_cols_V_channel_empty_n : STD_LOGIC;
    signal img_1_cols_V_channel_read : STD_LOGIC;
    signal C_XR0C0_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR0C0_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C0_channel_full_n : STD_LOGIC;
    signal C_XR0C0_channel_write : STD_LOGIC;
    signal C_XR0C0_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C0_channel_empty_n : STD_LOGIC;
    signal C_XR0C0_channel_read : STD_LOGIC;
    signal C_YR0C2_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR0C2_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C2_channel_full_n : STD_LOGIC;
    signal C_YR0C2_channel_write : STD_LOGIC;
    signal C_YR0C2_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C2_channel_empty_n : STD_LOGIC;
    signal C_YR0C2_channel_read : STD_LOGIC;
    signal C_YR0C1_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR0C1_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C1_channel_full_n : STD_LOGIC;
    signal C_YR0C1_channel_write : STD_LOGIC;
    signal C_YR0C1_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C1_channel_empty_n : STD_LOGIC;
    signal C_YR0C1_channel_read : STD_LOGIC;
    signal c_high_thresh_channel_U_ap_dummy_ce : STD_LOGIC;
    signal c_high_thresh_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal c_high_thresh_channel_full_n : STD_LOGIC;
    signal c_high_thresh_channel_write : STD_LOGIC;
    signal c_high_thresh_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal c_high_thresh_channel_empty_n : STD_LOGIC;
    signal c_high_thresh_channel_read : STD_LOGIC;
    signal C_YR1C1_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR1C1_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C1_channel_full_n : STD_LOGIC;
    signal C_YR1C1_channel_write : STD_LOGIC;
    signal C_YR1C1_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C1_channel_empty_n : STD_LOGIC;
    signal C_YR1C1_channel_read : STD_LOGIC;
    signal C_YR1C0_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR1C0_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C0_channel_full_n : STD_LOGIC;
    signal C_YR1C0_channel_write : STD_LOGIC;
    signal C_YR1C0_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C0_channel_empty_n : STD_LOGIC;
    signal C_YR1C0_channel_read : STD_LOGIC;
    signal C_XR0C2_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR0C2_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C2_channel_full_n : STD_LOGIC;
    signal C_XR0C2_channel_write : STD_LOGIC;
    signal C_XR0C2_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C2_channel_empty_n : STD_LOGIC;
    signal C_XR0C2_channel_read : STD_LOGIC;
    signal C_XR0C1_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR0C1_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C1_channel_full_n : STD_LOGIC;
    signal C_XR0C1_channel_write : STD_LOGIC;
    signal C_XR0C1_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR0C1_channel_empty_n : STD_LOGIC;
    signal C_XR0C1_channel_read : STD_LOGIC;
    signal C_YR2C1_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR2C1_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C1_channel_full_n : STD_LOGIC;
    signal C_YR2C1_channel_write : STD_LOGIC;
    signal C_YR2C1_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C1_channel_empty_n : STD_LOGIC;
    signal C_YR2C1_channel_read : STD_LOGIC;
    signal C_XR2C0_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR2C0_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C0_channel_full_n : STD_LOGIC;
    signal C_XR2C0_channel_write : STD_LOGIC;
    signal C_XR2C0_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C0_channel_empty_n : STD_LOGIC;
    signal C_XR2C0_channel_read : STD_LOGIC;
    signal C_XR1C0_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR1C0_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C0_channel_full_n : STD_LOGIC;
    signal C_XR1C0_channel_write : STD_LOGIC;
    signal C_XR1C0_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C0_channel_empty_n : STD_LOGIC;
    signal C_XR1C0_channel_read : STD_LOGIC;
    signal C_YR1C2_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR1C2_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C2_channel_full_n : STD_LOGIC;
    signal C_YR1C2_channel_write : STD_LOGIC;
    signal C_YR1C2_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR1C2_channel_empty_n : STD_LOGIC;
    signal C_YR1C2_channel_read : STD_LOGIC;
    signal C_XR1C2_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR1C2_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C2_channel_full_n : STD_LOGIC;
    signal C_XR1C2_channel_write : STD_LOGIC;
    signal C_XR1C2_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C2_channel_empty_n : STD_LOGIC;
    signal C_XR1C2_channel_read : STD_LOGIC;
    signal C_XR1C1_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR1C1_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C1_channel_full_n : STD_LOGIC;
    signal C_XR1C1_channel_write : STD_LOGIC;
    signal C_XR1C1_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR1C1_channel_empty_n : STD_LOGIC;
    signal C_XR1C1_channel_read : STD_LOGIC;
    signal C_YR2C0_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR2C0_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C0_channel_full_n : STD_LOGIC;
    signal C_YR2C0_channel_write : STD_LOGIC;
    signal C_YR2C0_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR2C0_channel_empty_n : STD_LOGIC;
    signal C_YR2C0_channel_read : STD_LOGIC;
    signal c_low_thresh_channel_U_ap_dummy_ce : STD_LOGIC;
    signal c_low_thresh_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal c_low_thresh_channel_full_n : STD_LOGIC;
    signal c_low_thresh_channel_write : STD_LOGIC;
    signal c_low_thresh_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal c_low_thresh_channel_empty_n : STD_LOGIC;
    signal c_low_thresh_channel_read : STD_LOGIC;
    signal c_invert_channel_U_ap_dummy_ce : STD_LOGIC;
    signal c_invert_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal c_invert_channel_full_n : STD_LOGIC;
    signal c_invert_channel_write : STD_LOGIC;
    signal c_invert_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal c_invert_channel_empty_n : STD_LOGIC;
    signal c_invert_channel_read : STD_LOGIC;
    signal C_YR0C0_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_YR0C0_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C0_channel_full_n : STD_LOGIC;
    signal C_YR0C0_channel_write : STD_LOGIC;
    signal C_YR0C0_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_YR0C0_channel_empty_n : STD_LOGIC;
    signal C_YR0C0_channel_read : STD_LOGIC;
    signal C_XR2C1_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR2C1_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C1_channel_full_n : STD_LOGIC;
    signal C_XR2C1_channel_write : STD_LOGIC;
    signal C_XR2C1_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C1_channel_empty_n : STD_LOGIC;
    signal C_XR2C1_channel_read : STD_LOGIC;
    signal C_XR2C2_channel_U_ap_dummy_ce : STD_LOGIC;
    signal C_XR2C2_channel_din : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C2_channel_full_n : STD_LOGIC;
    signal C_XR2C2_channel_write : STD_LOGIC;
    signal C_XR2C2_channel_dout : STD_LOGIC_VECTOR (31 downto 0);
    signal C_XR2C2_channel_empty_n : STD_LOGIC;
    signal C_XR2C2_channel_read : STD_LOGIC;
    signal img_0_rows_V_channel_U_ap_dummy_ce : STD_LOGIC;
    signal img_0_rows_V_channel_din : STD_LOGIC_VECTOR (11 downto 0);
    signal img_0_rows_V_channel_write : STD_LOGIC;
    signal img_0_rows_V_channel_dout : STD_LOGIC_VECTOR (11 downto 0);
    signal img_0_rows_V_channel_empty_n : STD_LOGIC;
    signal img_0_rows_V_channel_read : STD_LOGIC;
    signal img_0_cols_V_channel_U_ap_dummy_ce : STD_LOGIC;
    signal img_0_cols_V_channel_din : STD_LOGIC_VECTOR (11 downto 0);
    signal img_0_cols_V_channel_write : STD_LOGIC;
    signal img_0_cols_V_channel_dout : STD_LOGIC_VECTOR (11 downto 0);
    signal img_0_cols_V_channel_empty_n : STD_LOGIC;
    signal img_0_cols_V_channel_read : STD_LOGIC;
    signal img_0_data_stream_0_V_U_ap_dummy_ce : STD_LOGIC;
    signal img_0_data_stream_0_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal img_0_data_stream_0_V_full_n : STD_LOGIC;
    signal img_0_data_stream_0_V_write : STD_LOGIC;
    signal img_0_data_stream_0_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal img_0_data_stream_0_V_empty_n : STD_LOGIC;
    signal img_0_data_stream_0_V_read : STD_LOGIC;
    signal img_0_data_stream_1_V_U_ap_dummy_ce : STD_LOGIC;
    signal img_0_data_stream_1_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal img_0_data_stream_1_V_full_n : STD_LOGIC;
    signal img_0_data_stream_1_V_write : STD_LOGIC;
    signal img_0_data_stream_1_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal img_0_data_stream_1_V_empty_n : STD_LOGIC;
    signal img_0_data_stream_1_V_read : STD_LOGIC;
    signal img_1_data_stream_0_V_U_ap_dummy_ce : STD_LOGIC;
    signal img_1_data_stream_0_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal img_1_data_stream_0_V_full_n : STD_LOGIC;
    signal img_1_data_stream_0_V_write : STD_LOGIC;
    signal img_1_data_stream_0_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal img_1_data_stream_0_V_empty_n : STD_LOGIC;
    signal img_1_data_stream_0_V_read : STD_LOGIC;
    signal img_1_data_stream_1_V_U_ap_dummy_ce : STD_LOGIC;
    signal img_1_data_stream_1_V_din : STD_LOGIC_VECTOR (7 downto 0);
    signal img_1_data_stream_1_V_full_n : STD_LOGIC;
    signal img_1_data_stream_1_V_write : STD_LOGIC;
    signal img_1_data_stream_1_V_dout : STD_LOGIC_VECTOR (7 downto 0);
    signal img_1_data_stream_1_V_empty_n : STD_LOGIC;
    signal img_1_data_stream_1_V_read : STD_LOGIC;
    signal ap_reg_procdone_image_filter_Block_Mat_exit45_proc42_U0 : STD_LOGIC := '0';
    signal ap_sig_hs_done : STD_LOGIC;
    signal ap_reg_procdone_image_filter_AXIvideo2Mat_U0 : STD_LOGIC := '0';
    signal ap_reg_procdone_image_filter_sobel_filter_core_U0 : STD_LOGIC := '0';
    signal ap_reg_procdone_image_filter_Mat2AXIvideo_U0 : STD_LOGIC := '0';
    signal ap_CS : STD_LOGIC;
    signal ap_sig_top_allready : STD_LOGIC;
    signal ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready : STD_LOGIC := '0';
    signal ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready : STD_LOGIC;
    signal ap_sig_start_in_image_filter_Block_Mat_exit45_proc42_U0_ap_start : STD_LOGIC;
    signal ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready : STD_LOGIC := '0';
    signal ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready : STD_LOGIC;
    signal ap_sig_start_in_image_filter_AXIvideo2Mat_U0_ap_start : STD_LOGIC;

    component image_filter_Block_Mat_exit45_proc42 IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        rows : IN STD_LOGIC_VECTOR (31 downto 0);
        cols : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C0 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C2 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C1 : IN STD_LOGIC_VECTOR (31 downto 0);
        c_high_thresh : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C1 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C0 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C2 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C1 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C1 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C0 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C0 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C2 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C2 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C1 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C0 : IN STD_LOGIC_VECTOR (31 downto 0);
        c_low_thresh : IN STD_LOGIC_VECTOR (31 downto 0);
        c_invert : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C0 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C1 : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C2 : IN STD_LOGIC_VECTOR (31 downto 0);
        rows_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        rows_out_full_n : IN STD_LOGIC;
        rows_out_write : OUT STD_LOGIC;
        cols_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        cols_out_full_n : IN STD_LOGIC;
        cols_out_write : OUT STD_LOGIC;
        img_1_rows_V_out_din : OUT STD_LOGIC_VECTOR (11 downto 0);
        img_1_rows_V_out_full_n : IN STD_LOGIC;
        img_1_rows_V_out_write : OUT STD_LOGIC;
        img_1_cols_V_out_din : OUT STD_LOGIC_VECTOR (11 downto 0);
        img_1_cols_V_out_full_n : IN STD_LOGIC;
        img_1_cols_V_out_write : OUT STD_LOGIC;
        C_XR0C0_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C0_out_full_n : IN STD_LOGIC;
        C_XR0C0_out_write : OUT STD_LOGIC;
        C_YR0C2_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C2_out_full_n : IN STD_LOGIC;
        C_YR0C2_out_write : OUT STD_LOGIC;
        C_YR0C1_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C1_out_full_n : IN STD_LOGIC;
        C_YR0C1_out_write : OUT STD_LOGIC;
        c_high_thresh_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        c_high_thresh_out_full_n : IN STD_LOGIC;
        c_high_thresh_out_write : OUT STD_LOGIC;
        C_YR1C1_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C1_out_full_n : IN STD_LOGIC;
        C_YR1C1_out_write : OUT STD_LOGIC;
        C_YR1C0_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C0_out_full_n : IN STD_LOGIC;
        C_YR1C0_out_write : OUT STD_LOGIC;
        C_XR0C2_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C2_out_full_n : IN STD_LOGIC;
        C_XR0C2_out_write : OUT STD_LOGIC;
        C_XR0C1_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C1_out_full_n : IN STD_LOGIC;
        C_XR0C1_out_write : OUT STD_LOGIC;
        C_YR2C1_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C1_out_full_n : IN STD_LOGIC;
        C_YR2C1_out_write : OUT STD_LOGIC;
        C_XR2C0_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C0_out_full_n : IN STD_LOGIC;
        C_XR2C0_out_write : OUT STD_LOGIC;
        C_XR1C0_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C0_out_full_n : IN STD_LOGIC;
        C_XR1C0_out_write : OUT STD_LOGIC;
        C_YR1C2_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C2_out_full_n : IN STD_LOGIC;
        C_YR1C2_out_write : OUT STD_LOGIC;
        C_XR1C2_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C2_out_full_n : IN STD_LOGIC;
        C_XR1C2_out_write : OUT STD_LOGIC;
        C_XR1C1_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C1_out_full_n : IN STD_LOGIC;
        C_XR1C1_out_write : OUT STD_LOGIC;
        C_YR2C0_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C0_out_full_n : IN STD_LOGIC;
        C_YR2C0_out_write : OUT STD_LOGIC;
        c_low_thresh_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        c_low_thresh_out_full_n : IN STD_LOGIC;
        c_low_thresh_out_write : OUT STD_LOGIC;
        c_invert_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        c_invert_out_full_n : IN STD_LOGIC;
        c_invert_out_write : OUT STD_LOGIC;
        C_YR0C0_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C0_out_full_n : IN STD_LOGIC;
        C_YR0C0_out_write : OUT STD_LOGIC;
        C_XR2C1_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C1_out_full_n : IN STD_LOGIC;
        C_XR2C1_out_write : OUT STD_LOGIC;
        C_XR2C2_out_din : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C2_out_full_n : IN STD_LOGIC;
        C_XR2C2_out_write : OUT STD_LOGIC;
        ap_return_0 : OUT STD_LOGIC_VECTOR (11 downto 0);
        ap_return_1 : OUT STD_LOGIC_VECTOR (11 downto 0) );
    end component;


    component image_filter_AXIvideo2Mat IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        video_in_TDATA : IN STD_LOGIC_VECTOR (15 downto 0);
        video_in_TVALID : IN STD_LOGIC;
        video_in_TREADY : OUT STD_LOGIC;
        video_in_TKEEP : IN STD_LOGIC_VECTOR (1 downto 0);
        video_in_TSTRB : IN STD_LOGIC_VECTOR (1 downto 0);
        video_in_TUSER : IN STD_LOGIC_VECTOR (0 downto 0);
        video_in_TLAST : IN STD_LOGIC_VECTOR (0 downto 0);
        video_in_TID : IN STD_LOGIC_VECTOR (0 downto 0);
        video_in_TDEST : IN STD_LOGIC_VECTOR (0 downto 0);
        img_rows_V_read : IN STD_LOGIC_VECTOR (11 downto 0);
        img_cols_V_read : IN STD_LOGIC_VECTOR (11 downto 0);
        img_data_stream_0_V_din : OUT STD_LOGIC_VECTOR (7 downto 0);
        img_data_stream_0_V_full_n : IN STD_LOGIC;
        img_data_stream_0_V_write : OUT STD_LOGIC;
        img_data_stream_1_V_din : OUT STD_LOGIC_VECTOR (7 downto 0);
        img_data_stream_1_V_full_n : IN STD_LOGIC;
        img_data_stream_1_V_write : OUT STD_LOGIC );
    end component;


    component image_filter_sobel_filter_core IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        src_data_stream_0_V_dout : IN STD_LOGIC_VECTOR (7 downto 0);
        src_data_stream_0_V_empty_n : IN STD_LOGIC;
        src_data_stream_0_V_read : OUT STD_LOGIC;
        src_data_stream_1_V_dout : IN STD_LOGIC_VECTOR (7 downto 0);
        src_data_stream_1_V_empty_n : IN STD_LOGIC;
        src_data_stream_1_V_read : OUT STD_LOGIC;
        dst_data_stream_0_V_din : OUT STD_LOGIC_VECTOR (7 downto 0);
        dst_data_stream_0_V_full_n : IN STD_LOGIC;
        dst_data_stream_0_V_write : OUT STD_LOGIC;
        dst_data_stream_1_V_din : OUT STD_LOGIC_VECTOR (7 downto 0);
        dst_data_stream_1_V_full_n : IN STD_LOGIC;
        dst_data_stream_1_V_write : OUT STD_LOGIC;
        rows_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        rows_empty_n : IN STD_LOGIC;
        rows_read : OUT STD_LOGIC;
        cols_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        cols_empty_n : IN STD_LOGIC;
        cols_read : OUT STD_LOGIC;
        C_XR0C0_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C0_empty_n : IN STD_LOGIC;
        C_XR0C0_read : OUT STD_LOGIC;
        C_XR0C1_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C1_empty_n : IN STD_LOGIC;
        C_XR0C1_read : OUT STD_LOGIC;
        C_XR0C2_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C2_empty_n : IN STD_LOGIC;
        C_XR0C2_read : OUT STD_LOGIC;
        C_XR1C0_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C0_empty_n : IN STD_LOGIC;
        C_XR1C0_read : OUT STD_LOGIC;
        C_XR1C1_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C1_empty_n : IN STD_LOGIC;
        C_XR1C1_read : OUT STD_LOGIC;
        C_XR1C2_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C2_empty_n : IN STD_LOGIC;
        C_XR1C2_read : OUT STD_LOGIC;
        C_XR2C0_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C0_empty_n : IN STD_LOGIC;
        C_XR2C0_read : OUT STD_LOGIC;
        C_XR2C1_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C1_empty_n : IN STD_LOGIC;
        C_XR2C1_read : OUT STD_LOGIC;
        C_XR2C2_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C2_empty_n : IN STD_LOGIC;
        C_XR2C2_read : OUT STD_LOGIC;
        C_YR0C0_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C0_empty_n : IN STD_LOGIC;
        C_YR0C0_read : OUT STD_LOGIC;
        C_YR0C1_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C1_empty_n : IN STD_LOGIC;
        C_YR0C1_read : OUT STD_LOGIC;
        C_YR0C2_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C2_empty_n : IN STD_LOGIC;
        C_YR0C2_read : OUT STD_LOGIC;
        C_YR1C0_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C0_empty_n : IN STD_LOGIC;
        C_YR1C0_read : OUT STD_LOGIC;
        C_YR1C1_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C1_empty_n : IN STD_LOGIC;
        C_YR1C1_read : OUT STD_LOGIC;
        C_YR1C2_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C2_empty_n : IN STD_LOGIC;
        C_YR1C2_read : OUT STD_LOGIC;
        C_YR2C0_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C0_empty_n : IN STD_LOGIC;
        C_YR2C0_read : OUT STD_LOGIC;
        C_YR2C1_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C1_empty_n : IN STD_LOGIC;
        C_YR2C1_read : OUT STD_LOGIC;
        c_high_thresh_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        c_high_thresh_empty_n : IN STD_LOGIC;
        c_high_thresh_read : OUT STD_LOGIC;
        c_low_thresh_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        c_low_thresh_empty_n : IN STD_LOGIC;
        c_low_thresh_read : OUT STD_LOGIC;
        c_invert_dout : IN STD_LOGIC_VECTOR (31 downto 0);
        c_invert_empty_n : IN STD_LOGIC;
        c_invert_read : OUT STD_LOGIC );
    end component;


    component image_filter_Mat2AXIvideo IS
    port (
        ap_clk : IN STD_LOGIC;
        ap_rst : IN STD_LOGIC;
        ap_start : IN STD_LOGIC;
        ap_done : OUT STD_LOGIC;
        ap_continue : IN STD_LOGIC;
        ap_idle : OUT STD_LOGIC;
        ap_ready : OUT STD_LOGIC;
        img_rows_V_dout : IN STD_LOGIC_VECTOR (11 downto 0);
        img_rows_V_empty_n : IN STD_LOGIC;
        img_rows_V_read : OUT STD_LOGIC;
        img_cols_V_dout : IN STD_LOGIC_VECTOR (11 downto 0);
        img_cols_V_empty_n : IN STD_LOGIC;
        img_cols_V_read : OUT STD_LOGIC;
        img_data_stream_0_V_dout : IN STD_LOGIC_VECTOR (7 downto 0);
        img_data_stream_0_V_empty_n : IN STD_LOGIC;
        img_data_stream_0_V_read : OUT STD_LOGIC;
        img_data_stream_1_V_dout : IN STD_LOGIC_VECTOR (7 downto 0);
        img_data_stream_1_V_empty_n : IN STD_LOGIC;
        img_data_stream_1_V_read : OUT STD_LOGIC;
        video_out_TDATA : OUT STD_LOGIC_VECTOR (15 downto 0);
        video_out_TVALID : OUT STD_LOGIC;
        video_out_TREADY : IN STD_LOGIC;
        video_out_TKEEP : OUT STD_LOGIC_VECTOR (1 downto 0);
        video_out_TSTRB : OUT STD_LOGIC_VECTOR (1 downto 0);
        video_out_TUSER : OUT STD_LOGIC_VECTOR (0 downto 0);
        video_out_TLAST : OUT STD_LOGIC_VECTOR (0 downto 0);
        video_out_TID : OUT STD_LOGIC_VECTOR (0 downto 0);
        video_out_TDEST : OUT STD_LOGIC_VECTOR (0 downto 0) );
    end component;


    component FIFO_image_filter_rows_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_cols_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_1_rows_V_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (11 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (11 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_1_cols_V_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (11 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (11 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR0C0_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR0C2_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR0C1_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_c_high_thresh_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR1C1_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR1C0_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR0C2_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR0C1_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR2C1_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR2C0_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR1C0_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR1C2_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR1C2_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR1C1_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR2C0_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_c_low_thresh_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_c_invert_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_YR0C0_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR2C1_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_C_XR2C2_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (31 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (31 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_0_rows_V_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (11 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (11 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_0_cols_V_channel IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (11 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (11 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_0_data_stream_0_V IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (7 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (7 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_0_data_stream_1_V IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (7 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (7 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_1_data_stream_0_V IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (7 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (7 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component FIFO_image_filter_img_1_data_stream_1_V IS
    port (
        clk : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        if_read_ce : IN STD_LOGIC;
        if_write_ce : IN STD_LOGIC;
        if_din : IN STD_LOGIC_VECTOR (7 downto 0);
        if_full_n : OUT STD_LOGIC;
        if_write : IN STD_LOGIC;
        if_dout : OUT STD_LOGIC_VECTOR (7 downto 0);
        if_empty_n : OUT STD_LOGIC;
        if_read : IN STD_LOGIC );
    end component;


    component image_filter_CONTROL_BUS_s_axi IS
    generic (
        C_S_AXI_ADDR_WIDTH : INTEGER;
        C_S_AXI_DATA_WIDTH : INTEGER );
    port (
        AWVALID : IN STD_LOGIC;
        AWREADY : OUT STD_LOGIC;
        AWADDR : IN STD_LOGIC_VECTOR (C_S_AXI_ADDR_WIDTH-1 downto 0);
        WVALID : IN STD_LOGIC;
        WREADY : OUT STD_LOGIC;
        WDATA : IN STD_LOGIC_VECTOR (C_S_AXI_DATA_WIDTH-1 downto 0);
        WSTRB : IN STD_LOGIC_VECTOR (C_S_AXI_DATA_WIDTH/8-1 downto 0);
        ARVALID : IN STD_LOGIC;
        ARREADY : OUT STD_LOGIC;
        ARADDR : IN STD_LOGIC_VECTOR (C_S_AXI_ADDR_WIDTH-1 downto 0);
        RVALID : OUT STD_LOGIC;
        RREADY : IN STD_LOGIC;
        RDATA : OUT STD_LOGIC_VECTOR (C_S_AXI_DATA_WIDTH-1 downto 0);
        RRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
        BVALID : OUT STD_LOGIC;
        BREADY : IN STD_LOGIC;
        BRESP : OUT STD_LOGIC_VECTOR (1 downto 0);
        ACLK : IN STD_LOGIC;
        ARESET : IN STD_LOGIC;
        ACLK_EN : IN STD_LOGIC;
        ap_start : OUT STD_LOGIC;
        interrupt : OUT STD_LOGIC;
        ap_ready : IN STD_LOGIC;
        ap_done : IN STD_LOGIC;
        ap_idle : IN STD_LOGIC;
        rows : OUT STD_LOGIC_VECTOR (31 downto 0);
        cols : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C0 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C1 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR0C2 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C0 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C1 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR1C2 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C0 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C1 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_XR2C2 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C0 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C1 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR0C2 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C0 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C1 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR1C2 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C0 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C1 : OUT STD_LOGIC_VECTOR (31 downto 0);
        C_YR2C2 : OUT STD_LOGIC_VECTOR (31 downto 0);
        c_high_thresh : OUT STD_LOGIC_VECTOR (31 downto 0);
        c_low_thresh : OUT STD_LOGIC_VECTOR (31 downto 0);
        c_invert : OUT STD_LOGIC_VECTOR (31 downto 0);
        clk : IN STD_LOGIC;
        rst : IN STD_LOGIC );
    end component;



begin
    image_filter_CONTROL_BUS_s_axi_U : component image_filter_CONTROL_BUS_s_axi
    generic map (
        C_S_AXI_ADDR_WIDTH => C_S_AXI_CONTROL_BUS_ADDR_WIDTH,
        C_S_AXI_DATA_WIDTH => C_S_AXI_CONTROL_BUS_DATA_WIDTH)
    port map (
        AWVALID => s_axi_CONTROL_BUS_AWVALID,
        AWREADY => s_axi_CONTROL_BUS_AWREADY,
        AWADDR => s_axi_CONTROL_BUS_AWADDR,
        WVALID => s_axi_CONTROL_BUS_WVALID,
        WREADY => s_axi_CONTROL_BUS_WREADY,
        WDATA => s_axi_CONTROL_BUS_WDATA,
        WSTRB => s_axi_CONTROL_BUS_WSTRB,
        ARVALID => s_axi_CONTROL_BUS_ARVALID,
        ARREADY => s_axi_CONTROL_BUS_ARREADY,
        ARADDR => s_axi_CONTROL_BUS_ARADDR,
        RVALID => s_axi_CONTROL_BUS_RVALID,
        RREADY => s_axi_CONTROL_BUS_RREADY,
        RDATA => s_axi_CONTROL_BUS_RDATA,
        RRESP => s_axi_CONTROL_BUS_RRESP,
        BVALID => s_axi_CONTROL_BUS_BVALID,
        BREADY => s_axi_CONTROL_BUS_BREADY,
        BRESP => s_axi_CONTROL_BUS_BRESP,
        ACLK => ap_clk,
        ARESET => ap_rst_n_inv,
        ACLK_EN => image_filter_CONTROL_BUS_s_axi_U_ap_dummy_ce,
        ap_start => ap_start,
        interrupt => interrupt,
        ap_ready => ap_ready,
        ap_done => ap_done,
        ap_idle => ap_idle,
        rows => rows,
        cols => cols,
        C_XR0C0 => C_XR0C0,
        C_XR0C1 => C_XR0C1,
        C_XR0C2 => C_XR0C2,
        C_XR1C0 => C_XR1C0,
        C_XR1C1 => C_XR1C1,
        C_XR1C2 => C_XR1C2,
        C_XR2C0 => C_XR2C0,
        C_XR2C1 => C_XR2C1,
        C_XR2C2 => C_XR2C2,
        C_YR0C0 => C_YR0C0,
        C_YR0C1 => C_YR0C1,
        C_YR0C2 => C_YR0C2,
        C_YR1C0 => C_YR1C0,
        C_YR1C1 => C_YR1C1,
        C_YR1C2 => C_YR1C2,
        C_YR2C0 => C_YR2C0,
        C_YR2C1 => C_YR2C1,
        C_YR2C2 => C_YR2C2,
        c_high_thresh => c_high_thresh,
        c_low_thresh => c_low_thresh,
        c_invert => c_invert,
        clk => axilite_clk,
        rst => ap_rst_n_axilite_clk_inv);

    image_filter_Block_Mat_exit45_proc42_U0 : component image_filter_Block_Mat_exit45_proc42
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => image_filter_Block_Mat_exit45_proc42_U0_ap_start,
        ap_done => image_filter_Block_Mat_exit45_proc42_U0_ap_done,
        ap_continue => image_filter_Block_Mat_exit45_proc42_U0_ap_continue,
        ap_idle => image_filter_Block_Mat_exit45_proc42_U0_ap_idle,
        ap_ready => image_filter_Block_Mat_exit45_proc42_U0_ap_ready,
        rows => image_filter_Block_Mat_exit45_proc42_U0_rows,
        cols => image_filter_Block_Mat_exit45_proc42_U0_cols,
        C_XR0C0 => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0,
        C_YR0C2 => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2,
        C_YR0C1 => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1,
        c_high_thresh => image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh,
        C_YR1C1 => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1,
        C_YR1C0 => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0,
        C_XR0C2 => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2,
        C_XR0C1 => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1,
        C_YR2C1 => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1,
        C_XR2C0 => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0,
        C_XR1C0 => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0,
        C_YR1C2 => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2,
        C_XR1C2 => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2,
        C_XR1C1 => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1,
        C_YR2C0 => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0,
        c_low_thresh => image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh,
        c_invert => image_filter_Block_Mat_exit45_proc42_U0_c_invert,
        C_YR0C0 => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0,
        C_XR2C1 => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1,
        C_XR2C2 => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2,
        rows_out_din => image_filter_Block_Mat_exit45_proc42_U0_rows_out_din,
        rows_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_rows_out_full_n,
        rows_out_write => image_filter_Block_Mat_exit45_proc42_U0_rows_out_write,
        cols_out_din => image_filter_Block_Mat_exit45_proc42_U0_cols_out_din,
        cols_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_cols_out_full_n,
        cols_out_write => image_filter_Block_Mat_exit45_proc42_U0_cols_out_write,
        img_1_rows_V_out_din => image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_din,
        img_1_rows_V_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_full_n,
        img_1_rows_V_out_write => image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_write,
        img_1_cols_V_out_din => image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_din,
        img_1_cols_V_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_full_n,
        img_1_cols_V_out_write => image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_write,
        C_XR0C0_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_din,
        C_XR0C0_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_full_n,
        C_XR0C0_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_write,
        C_YR0C2_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_din,
        C_YR0C2_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_full_n,
        C_YR0C2_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_write,
        C_YR0C1_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_din,
        C_YR0C1_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_full_n,
        C_YR0C1_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_write,
        c_high_thresh_out_din => image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_din,
        c_high_thresh_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_full_n,
        c_high_thresh_out_write => image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_write,
        C_YR1C1_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_din,
        C_YR1C1_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_full_n,
        C_YR1C1_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_write,
        C_YR1C0_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_din,
        C_YR1C0_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_full_n,
        C_YR1C0_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_write,
        C_XR0C2_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_din,
        C_XR0C2_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_full_n,
        C_XR0C2_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_write,
        C_XR0C1_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_din,
        C_XR0C1_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_full_n,
        C_XR0C1_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_write,
        C_YR2C1_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_din,
        C_YR2C1_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_full_n,
        C_YR2C1_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_write,
        C_XR2C0_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_din,
        C_XR2C0_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_full_n,
        C_XR2C0_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_write,
        C_XR1C0_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_din,
        C_XR1C0_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_full_n,
        C_XR1C0_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_write,
        C_YR1C2_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_din,
        C_YR1C2_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_full_n,
        C_YR1C2_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_write,
        C_XR1C2_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_din,
        C_XR1C2_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_full_n,
        C_XR1C2_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_write,
        C_XR1C1_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_din,
        C_XR1C1_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_full_n,
        C_XR1C1_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_write,
        C_YR2C0_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_din,
        C_YR2C0_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_full_n,
        C_YR2C0_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_write,
        c_low_thresh_out_din => image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_din,
        c_low_thresh_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_full_n,
        c_low_thresh_out_write => image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_write,
        c_invert_out_din => image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_din,
        c_invert_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_full_n,
        c_invert_out_write => image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_write,
        C_YR0C0_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_din,
        C_YR0C0_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_full_n,
        C_YR0C0_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_write,
        C_XR2C1_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_din,
        C_XR2C1_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_full_n,
        C_XR2C1_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_write,
        C_XR2C2_out_din => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_din,
        C_XR2C2_out_full_n => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_full_n,
        C_XR2C2_out_write => image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_write,
        ap_return_0 => image_filter_Block_Mat_exit45_proc42_U0_ap_return_0,
        ap_return_1 => image_filter_Block_Mat_exit45_proc42_U0_ap_return_1);

    image_filter_AXIvideo2Mat_U0 : component image_filter_AXIvideo2Mat
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => image_filter_AXIvideo2Mat_U0_ap_start,
        ap_done => image_filter_AXIvideo2Mat_U0_ap_done,
        ap_continue => image_filter_AXIvideo2Mat_U0_ap_continue,
        ap_idle => image_filter_AXIvideo2Mat_U0_ap_idle,
        ap_ready => image_filter_AXIvideo2Mat_U0_ap_ready,
        video_in_TDATA => image_filter_AXIvideo2Mat_U0_video_in_TDATA,
        video_in_TVALID => image_filter_AXIvideo2Mat_U0_video_in_TVALID,
        video_in_TREADY => image_filter_AXIvideo2Mat_U0_video_in_TREADY,
        video_in_TKEEP => image_filter_AXIvideo2Mat_U0_video_in_TKEEP,
        video_in_TSTRB => image_filter_AXIvideo2Mat_U0_video_in_TSTRB,
        video_in_TUSER => image_filter_AXIvideo2Mat_U0_video_in_TUSER,
        video_in_TLAST => image_filter_AXIvideo2Mat_U0_video_in_TLAST,
        video_in_TID => image_filter_AXIvideo2Mat_U0_video_in_TID,
        video_in_TDEST => image_filter_AXIvideo2Mat_U0_video_in_TDEST,
        img_rows_V_read => image_filter_AXIvideo2Mat_U0_img_rows_V_read,
        img_cols_V_read => image_filter_AXIvideo2Mat_U0_img_cols_V_read,
        img_data_stream_0_V_din => image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_din,
        img_data_stream_0_V_full_n => image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_full_n,
        img_data_stream_0_V_write => image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_write,
        img_data_stream_1_V_din => image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_din,
        img_data_stream_1_V_full_n => image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_full_n,
        img_data_stream_1_V_write => image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_write);

    image_filter_sobel_filter_core_U0 : component image_filter_sobel_filter_core
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => image_filter_sobel_filter_core_U0_ap_start,
        ap_done => image_filter_sobel_filter_core_U0_ap_done,
        ap_continue => image_filter_sobel_filter_core_U0_ap_continue,
        ap_idle => image_filter_sobel_filter_core_U0_ap_idle,
        ap_ready => image_filter_sobel_filter_core_U0_ap_ready,
        src_data_stream_0_V_dout => image_filter_sobel_filter_core_U0_src_data_stream_0_V_dout,
        src_data_stream_0_V_empty_n => image_filter_sobel_filter_core_U0_src_data_stream_0_V_empty_n,
        src_data_stream_0_V_read => image_filter_sobel_filter_core_U0_src_data_stream_0_V_read,
        src_data_stream_1_V_dout => image_filter_sobel_filter_core_U0_src_data_stream_1_V_dout,
        src_data_stream_1_V_empty_n => image_filter_sobel_filter_core_U0_src_data_stream_1_V_empty_n,
        src_data_stream_1_V_read => image_filter_sobel_filter_core_U0_src_data_stream_1_V_read,
        dst_data_stream_0_V_din => image_filter_sobel_filter_core_U0_dst_data_stream_0_V_din,
        dst_data_stream_0_V_full_n => image_filter_sobel_filter_core_U0_dst_data_stream_0_V_full_n,
        dst_data_stream_0_V_write => image_filter_sobel_filter_core_U0_dst_data_stream_0_V_write,
        dst_data_stream_1_V_din => image_filter_sobel_filter_core_U0_dst_data_stream_1_V_din,
        dst_data_stream_1_V_full_n => image_filter_sobel_filter_core_U0_dst_data_stream_1_V_full_n,
        dst_data_stream_1_V_write => image_filter_sobel_filter_core_U0_dst_data_stream_1_V_write,
        rows_dout => image_filter_sobel_filter_core_U0_rows_dout,
        rows_empty_n => image_filter_sobel_filter_core_U0_rows_empty_n,
        rows_read => image_filter_sobel_filter_core_U0_rows_read,
        cols_dout => image_filter_sobel_filter_core_U0_cols_dout,
        cols_empty_n => image_filter_sobel_filter_core_U0_cols_empty_n,
        cols_read => image_filter_sobel_filter_core_U0_cols_read,
        C_XR0C0_dout => image_filter_sobel_filter_core_U0_C_XR0C0_dout,
        C_XR0C0_empty_n => image_filter_sobel_filter_core_U0_C_XR0C0_empty_n,
        C_XR0C0_read => image_filter_sobel_filter_core_U0_C_XR0C0_read,
        C_XR0C1_dout => image_filter_sobel_filter_core_U0_C_XR0C1_dout,
        C_XR0C1_empty_n => image_filter_sobel_filter_core_U0_C_XR0C1_empty_n,
        C_XR0C1_read => image_filter_sobel_filter_core_U0_C_XR0C1_read,
        C_XR0C2_dout => image_filter_sobel_filter_core_U0_C_XR0C2_dout,
        C_XR0C2_empty_n => image_filter_sobel_filter_core_U0_C_XR0C2_empty_n,
        C_XR0C2_read => image_filter_sobel_filter_core_U0_C_XR0C2_read,
        C_XR1C0_dout => image_filter_sobel_filter_core_U0_C_XR1C0_dout,
        C_XR1C0_empty_n => image_filter_sobel_filter_core_U0_C_XR1C0_empty_n,
        C_XR1C0_read => image_filter_sobel_filter_core_U0_C_XR1C0_read,
        C_XR1C1_dout => image_filter_sobel_filter_core_U0_C_XR1C1_dout,
        C_XR1C1_empty_n => image_filter_sobel_filter_core_U0_C_XR1C1_empty_n,
        C_XR1C1_read => image_filter_sobel_filter_core_U0_C_XR1C1_read,
        C_XR1C2_dout => image_filter_sobel_filter_core_U0_C_XR1C2_dout,
        C_XR1C2_empty_n => image_filter_sobel_filter_core_U0_C_XR1C2_empty_n,
        C_XR1C2_read => image_filter_sobel_filter_core_U0_C_XR1C2_read,
        C_XR2C0_dout => image_filter_sobel_filter_core_U0_C_XR2C0_dout,
        C_XR2C0_empty_n => image_filter_sobel_filter_core_U0_C_XR2C0_empty_n,
        C_XR2C0_read => image_filter_sobel_filter_core_U0_C_XR2C0_read,
        C_XR2C1_dout => image_filter_sobel_filter_core_U0_C_XR2C1_dout,
        C_XR2C1_empty_n => image_filter_sobel_filter_core_U0_C_XR2C1_empty_n,
        C_XR2C1_read => image_filter_sobel_filter_core_U0_C_XR2C1_read,
        C_XR2C2_dout => image_filter_sobel_filter_core_U0_C_XR2C2_dout,
        C_XR2C2_empty_n => image_filter_sobel_filter_core_U0_C_XR2C2_empty_n,
        C_XR2C2_read => image_filter_sobel_filter_core_U0_C_XR2C2_read,
        C_YR0C0_dout => image_filter_sobel_filter_core_U0_C_YR0C0_dout,
        C_YR0C0_empty_n => image_filter_sobel_filter_core_U0_C_YR0C0_empty_n,
        C_YR0C0_read => image_filter_sobel_filter_core_U0_C_YR0C0_read,
        C_YR0C1_dout => image_filter_sobel_filter_core_U0_C_YR0C1_dout,
        C_YR0C1_empty_n => image_filter_sobel_filter_core_U0_C_YR0C1_empty_n,
        C_YR0C1_read => image_filter_sobel_filter_core_U0_C_YR0C1_read,
        C_YR0C2_dout => image_filter_sobel_filter_core_U0_C_YR0C2_dout,
        C_YR0C2_empty_n => image_filter_sobel_filter_core_U0_C_YR0C2_empty_n,
        C_YR0C2_read => image_filter_sobel_filter_core_U0_C_YR0C2_read,
        C_YR1C0_dout => image_filter_sobel_filter_core_U0_C_YR1C0_dout,
        C_YR1C0_empty_n => image_filter_sobel_filter_core_U0_C_YR1C0_empty_n,
        C_YR1C0_read => image_filter_sobel_filter_core_U0_C_YR1C0_read,
        C_YR1C1_dout => image_filter_sobel_filter_core_U0_C_YR1C1_dout,
        C_YR1C1_empty_n => image_filter_sobel_filter_core_U0_C_YR1C1_empty_n,
        C_YR1C1_read => image_filter_sobel_filter_core_U0_C_YR1C1_read,
        C_YR1C2_dout => image_filter_sobel_filter_core_U0_C_YR1C2_dout,
        C_YR1C2_empty_n => image_filter_sobel_filter_core_U0_C_YR1C2_empty_n,
        C_YR1C2_read => image_filter_sobel_filter_core_U0_C_YR1C2_read,
        C_YR2C0_dout => image_filter_sobel_filter_core_U0_C_YR2C0_dout,
        C_YR2C0_empty_n => image_filter_sobel_filter_core_U0_C_YR2C0_empty_n,
        C_YR2C0_read => image_filter_sobel_filter_core_U0_C_YR2C0_read,
        C_YR2C1_dout => image_filter_sobel_filter_core_U0_C_YR2C1_dout,
        C_YR2C1_empty_n => image_filter_sobel_filter_core_U0_C_YR2C1_empty_n,
        C_YR2C1_read => image_filter_sobel_filter_core_U0_C_YR2C1_read,
        c_high_thresh_dout => image_filter_sobel_filter_core_U0_c_high_thresh_dout,
        c_high_thresh_empty_n => image_filter_sobel_filter_core_U0_c_high_thresh_empty_n,
        c_high_thresh_read => image_filter_sobel_filter_core_U0_c_high_thresh_read,
        c_low_thresh_dout => image_filter_sobel_filter_core_U0_c_low_thresh_dout,
        c_low_thresh_empty_n => image_filter_sobel_filter_core_U0_c_low_thresh_empty_n,
        c_low_thresh_read => image_filter_sobel_filter_core_U0_c_low_thresh_read,
        c_invert_dout => image_filter_sobel_filter_core_U0_c_invert_dout,
        c_invert_empty_n => image_filter_sobel_filter_core_U0_c_invert_empty_n,
        c_invert_read => image_filter_sobel_filter_core_U0_c_invert_read);

    image_filter_Mat2AXIvideo_U0 : component image_filter_Mat2AXIvideo
    port map (
        ap_clk => ap_clk,
        ap_rst => ap_rst_n_inv,
        ap_start => image_filter_Mat2AXIvideo_U0_ap_start,
        ap_done => image_filter_Mat2AXIvideo_U0_ap_done,
        ap_continue => image_filter_Mat2AXIvideo_U0_ap_continue,
        ap_idle => image_filter_Mat2AXIvideo_U0_ap_idle,
        ap_ready => image_filter_Mat2AXIvideo_U0_ap_ready,
        img_rows_V_dout => image_filter_Mat2AXIvideo_U0_img_rows_V_dout,
        img_rows_V_empty_n => image_filter_Mat2AXIvideo_U0_img_rows_V_empty_n,
        img_rows_V_read => image_filter_Mat2AXIvideo_U0_img_rows_V_read,
        img_cols_V_dout => image_filter_Mat2AXIvideo_U0_img_cols_V_dout,
        img_cols_V_empty_n => image_filter_Mat2AXIvideo_U0_img_cols_V_empty_n,
        img_cols_V_read => image_filter_Mat2AXIvideo_U0_img_cols_V_read,
        img_data_stream_0_V_dout => image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_dout,
        img_data_stream_0_V_empty_n => image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_empty_n,
        img_data_stream_0_V_read => image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_read,
        img_data_stream_1_V_dout => image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_dout,
        img_data_stream_1_V_empty_n => image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_empty_n,
        img_data_stream_1_V_read => image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_read,
        video_out_TDATA => image_filter_Mat2AXIvideo_U0_video_out_TDATA,
        video_out_TVALID => image_filter_Mat2AXIvideo_U0_video_out_TVALID,
        video_out_TREADY => image_filter_Mat2AXIvideo_U0_video_out_TREADY,
        video_out_TKEEP => image_filter_Mat2AXIvideo_U0_video_out_TKEEP,
        video_out_TSTRB => image_filter_Mat2AXIvideo_U0_video_out_TSTRB,
        video_out_TUSER => image_filter_Mat2AXIvideo_U0_video_out_TUSER,
        video_out_TLAST => image_filter_Mat2AXIvideo_U0_video_out_TLAST,
        video_out_TID => image_filter_Mat2AXIvideo_U0_video_out_TID,
        video_out_TDEST => image_filter_Mat2AXIvideo_U0_video_out_TDEST);

    rows_channel_U : component FIFO_image_filter_rows_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => rows_channel_U_ap_dummy_ce,
        if_write_ce => rows_channel_U_ap_dummy_ce,
        if_din => rows_channel_din,
        if_full_n => rows_channel_full_n,
        if_write => rows_channel_write,
        if_dout => rows_channel_dout,
        if_empty_n => rows_channel_empty_n,
        if_read => rows_channel_read);

    cols_channel_U : component FIFO_image_filter_cols_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => cols_channel_U_ap_dummy_ce,
        if_write_ce => cols_channel_U_ap_dummy_ce,
        if_din => cols_channel_din,
        if_full_n => cols_channel_full_n,
        if_write => cols_channel_write,
        if_dout => cols_channel_dout,
        if_empty_n => cols_channel_empty_n,
        if_read => cols_channel_read);

    img_1_rows_V_channel_U : component FIFO_image_filter_img_1_rows_V_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_1_rows_V_channel_U_ap_dummy_ce,
        if_write_ce => img_1_rows_V_channel_U_ap_dummy_ce,
        if_din => img_1_rows_V_channel_din,
        if_full_n => img_1_rows_V_channel_full_n,
        if_write => img_1_rows_V_channel_write,
        if_dout => img_1_rows_V_channel_dout,
        if_empty_n => img_1_rows_V_channel_empty_n,
        if_read => img_1_rows_V_channel_read);

    img_1_cols_V_channel_U : component FIFO_image_filter_img_1_cols_V_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_1_cols_V_channel_U_ap_dummy_ce,
        if_write_ce => img_1_cols_V_channel_U_ap_dummy_ce,
        if_din => img_1_cols_V_channel_din,
        if_full_n => img_1_cols_V_channel_full_n,
        if_write => img_1_cols_V_channel_write,
        if_dout => img_1_cols_V_channel_dout,
        if_empty_n => img_1_cols_V_channel_empty_n,
        if_read => img_1_cols_V_channel_read);

    C_XR0C0_channel_U : component FIFO_image_filter_C_XR0C0_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR0C0_channel_U_ap_dummy_ce,
        if_write_ce => C_XR0C0_channel_U_ap_dummy_ce,
        if_din => C_XR0C0_channel_din,
        if_full_n => C_XR0C0_channel_full_n,
        if_write => C_XR0C0_channel_write,
        if_dout => C_XR0C0_channel_dout,
        if_empty_n => C_XR0C0_channel_empty_n,
        if_read => C_XR0C0_channel_read);

    C_YR0C2_channel_U : component FIFO_image_filter_C_YR0C2_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR0C2_channel_U_ap_dummy_ce,
        if_write_ce => C_YR0C2_channel_U_ap_dummy_ce,
        if_din => C_YR0C2_channel_din,
        if_full_n => C_YR0C2_channel_full_n,
        if_write => C_YR0C2_channel_write,
        if_dout => C_YR0C2_channel_dout,
        if_empty_n => C_YR0C2_channel_empty_n,
        if_read => C_YR0C2_channel_read);

    C_YR0C1_channel_U : component FIFO_image_filter_C_YR0C1_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR0C1_channel_U_ap_dummy_ce,
        if_write_ce => C_YR0C1_channel_U_ap_dummy_ce,
        if_din => C_YR0C1_channel_din,
        if_full_n => C_YR0C1_channel_full_n,
        if_write => C_YR0C1_channel_write,
        if_dout => C_YR0C1_channel_dout,
        if_empty_n => C_YR0C1_channel_empty_n,
        if_read => C_YR0C1_channel_read);

    c_high_thresh_channel_U : component FIFO_image_filter_c_high_thresh_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => c_high_thresh_channel_U_ap_dummy_ce,
        if_write_ce => c_high_thresh_channel_U_ap_dummy_ce,
        if_din => c_high_thresh_channel_din,
        if_full_n => c_high_thresh_channel_full_n,
        if_write => c_high_thresh_channel_write,
        if_dout => c_high_thresh_channel_dout,
        if_empty_n => c_high_thresh_channel_empty_n,
        if_read => c_high_thresh_channel_read);

    C_YR1C1_channel_U : component FIFO_image_filter_C_YR1C1_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR1C1_channel_U_ap_dummy_ce,
        if_write_ce => C_YR1C1_channel_U_ap_dummy_ce,
        if_din => C_YR1C1_channel_din,
        if_full_n => C_YR1C1_channel_full_n,
        if_write => C_YR1C1_channel_write,
        if_dout => C_YR1C1_channel_dout,
        if_empty_n => C_YR1C1_channel_empty_n,
        if_read => C_YR1C1_channel_read);

    C_YR1C0_channel_U : component FIFO_image_filter_C_YR1C0_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR1C0_channel_U_ap_dummy_ce,
        if_write_ce => C_YR1C0_channel_U_ap_dummy_ce,
        if_din => C_YR1C0_channel_din,
        if_full_n => C_YR1C0_channel_full_n,
        if_write => C_YR1C0_channel_write,
        if_dout => C_YR1C0_channel_dout,
        if_empty_n => C_YR1C0_channel_empty_n,
        if_read => C_YR1C0_channel_read);

    C_XR0C2_channel_U : component FIFO_image_filter_C_XR0C2_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR0C2_channel_U_ap_dummy_ce,
        if_write_ce => C_XR0C2_channel_U_ap_dummy_ce,
        if_din => C_XR0C2_channel_din,
        if_full_n => C_XR0C2_channel_full_n,
        if_write => C_XR0C2_channel_write,
        if_dout => C_XR0C2_channel_dout,
        if_empty_n => C_XR0C2_channel_empty_n,
        if_read => C_XR0C2_channel_read);

    C_XR0C1_channel_U : component FIFO_image_filter_C_XR0C1_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR0C1_channel_U_ap_dummy_ce,
        if_write_ce => C_XR0C1_channel_U_ap_dummy_ce,
        if_din => C_XR0C1_channel_din,
        if_full_n => C_XR0C1_channel_full_n,
        if_write => C_XR0C1_channel_write,
        if_dout => C_XR0C1_channel_dout,
        if_empty_n => C_XR0C1_channel_empty_n,
        if_read => C_XR0C1_channel_read);

    C_YR2C1_channel_U : component FIFO_image_filter_C_YR2C1_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR2C1_channel_U_ap_dummy_ce,
        if_write_ce => C_YR2C1_channel_U_ap_dummy_ce,
        if_din => C_YR2C1_channel_din,
        if_full_n => C_YR2C1_channel_full_n,
        if_write => C_YR2C1_channel_write,
        if_dout => C_YR2C1_channel_dout,
        if_empty_n => C_YR2C1_channel_empty_n,
        if_read => C_YR2C1_channel_read);

    C_XR2C0_channel_U : component FIFO_image_filter_C_XR2C0_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR2C0_channel_U_ap_dummy_ce,
        if_write_ce => C_XR2C0_channel_U_ap_dummy_ce,
        if_din => C_XR2C0_channel_din,
        if_full_n => C_XR2C0_channel_full_n,
        if_write => C_XR2C0_channel_write,
        if_dout => C_XR2C0_channel_dout,
        if_empty_n => C_XR2C0_channel_empty_n,
        if_read => C_XR2C0_channel_read);

    C_XR1C0_channel_U : component FIFO_image_filter_C_XR1C0_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR1C0_channel_U_ap_dummy_ce,
        if_write_ce => C_XR1C0_channel_U_ap_dummy_ce,
        if_din => C_XR1C0_channel_din,
        if_full_n => C_XR1C0_channel_full_n,
        if_write => C_XR1C0_channel_write,
        if_dout => C_XR1C0_channel_dout,
        if_empty_n => C_XR1C0_channel_empty_n,
        if_read => C_XR1C0_channel_read);

    C_YR1C2_channel_U : component FIFO_image_filter_C_YR1C2_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR1C2_channel_U_ap_dummy_ce,
        if_write_ce => C_YR1C2_channel_U_ap_dummy_ce,
        if_din => C_YR1C2_channel_din,
        if_full_n => C_YR1C2_channel_full_n,
        if_write => C_YR1C2_channel_write,
        if_dout => C_YR1C2_channel_dout,
        if_empty_n => C_YR1C2_channel_empty_n,
        if_read => C_YR1C2_channel_read);

    C_XR1C2_channel_U : component FIFO_image_filter_C_XR1C2_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR1C2_channel_U_ap_dummy_ce,
        if_write_ce => C_XR1C2_channel_U_ap_dummy_ce,
        if_din => C_XR1C2_channel_din,
        if_full_n => C_XR1C2_channel_full_n,
        if_write => C_XR1C2_channel_write,
        if_dout => C_XR1C2_channel_dout,
        if_empty_n => C_XR1C2_channel_empty_n,
        if_read => C_XR1C2_channel_read);

    C_XR1C1_channel_U : component FIFO_image_filter_C_XR1C1_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR1C1_channel_U_ap_dummy_ce,
        if_write_ce => C_XR1C1_channel_U_ap_dummy_ce,
        if_din => C_XR1C1_channel_din,
        if_full_n => C_XR1C1_channel_full_n,
        if_write => C_XR1C1_channel_write,
        if_dout => C_XR1C1_channel_dout,
        if_empty_n => C_XR1C1_channel_empty_n,
        if_read => C_XR1C1_channel_read);

    C_YR2C0_channel_U : component FIFO_image_filter_C_YR2C0_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR2C0_channel_U_ap_dummy_ce,
        if_write_ce => C_YR2C0_channel_U_ap_dummy_ce,
        if_din => C_YR2C0_channel_din,
        if_full_n => C_YR2C0_channel_full_n,
        if_write => C_YR2C0_channel_write,
        if_dout => C_YR2C0_channel_dout,
        if_empty_n => C_YR2C0_channel_empty_n,
        if_read => C_YR2C0_channel_read);

    c_low_thresh_channel_U : component FIFO_image_filter_c_low_thresh_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => c_low_thresh_channel_U_ap_dummy_ce,
        if_write_ce => c_low_thresh_channel_U_ap_dummy_ce,
        if_din => c_low_thresh_channel_din,
        if_full_n => c_low_thresh_channel_full_n,
        if_write => c_low_thresh_channel_write,
        if_dout => c_low_thresh_channel_dout,
        if_empty_n => c_low_thresh_channel_empty_n,
        if_read => c_low_thresh_channel_read);

    c_invert_channel_U : component FIFO_image_filter_c_invert_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => c_invert_channel_U_ap_dummy_ce,
        if_write_ce => c_invert_channel_U_ap_dummy_ce,
        if_din => c_invert_channel_din,
        if_full_n => c_invert_channel_full_n,
        if_write => c_invert_channel_write,
        if_dout => c_invert_channel_dout,
        if_empty_n => c_invert_channel_empty_n,
        if_read => c_invert_channel_read);

    C_YR0C0_channel_U : component FIFO_image_filter_C_YR0C0_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_YR0C0_channel_U_ap_dummy_ce,
        if_write_ce => C_YR0C0_channel_U_ap_dummy_ce,
        if_din => C_YR0C0_channel_din,
        if_full_n => C_YR0C0_channel_full_n,
        if_write => C_YR0C0_channel_write,
        if_dout => C_YR0C0_channel_dout,
        if_empty_n => C_YR0C0_channel_empty_n,
        if_read => C_YR0C0_channel_read);

    C_XR2C1_channel_U : component FIFO_image_filter_C_XR2C1_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR2C1_channel_U_ap_dummy_ce,
        if_write_ce => C_XR2C1_channel_U_ap_dummy_ce,
        if_din => C_XR2C1_channel_din,
        if_full_n => C_XR2C1_channel_full_n,
        if_write => C_XR2C1_channel_write,
        if_dout => C_XR2C1_channel_dout,
        if_empty_n => C_XR2C1_channel_empty_n,
        if_read => C_XR2C1_channel_read);

    C_XR2C2_channel_U : component FIFO_image_filter_C_XR2C2_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => C_XR2C2_channel_U_ap_dummy_ce,
        if_write_ce => C_XR2C2_channel_U_ap_dummy_ce,
        if_din => C_XR2C2_channel_din,
        if_full_n => C_XR2C2_channel_full_n,
        if_write => C_XR2C2_channel_write,
        if_dout => C_XR2C2_channel_dout,
        if_empty_n => C_XR2C2_channel_empty_n,
        if_read => C_XR2C2_channel_read);

    img_0_rows_V_channel_U : component FIFO_image_filter_img_0_rows_V_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_0_rows_V_channel_U_ap_dummy_ce,
        if_write_ce => img_0_rows_V_channel_U_ap_dummy_ce,
        if_din => img_0_rows_V_channel_din,
        if_full_n => img_0_rows_V_channel_full_n,
        if_write => img_0_rows_V_channel_write,
        if_dout => img_0_rows_V_channel_dout,
        if_empty_n => img_0_rows_V_channel_empty_n,
        if_read => img_0_rows_V_channel_read);

    img_0_cols_V_channel_U : component FIFO_image_filter_img_0_cols_V_channel
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_0_cols_V_channel_U_ap_dummy_ce,
        if_write_ce => img_0_cols_V_channel_U_ap_dummy_ce,
        if_din => img_0_cols_V_channel_din,
        if_full_n => img_0_cols_V_channel_full_n,
        if_write => img_0_cols_V_channel_write,
        if_dout => img_0_cols_V_channel_dout,
        if_empty_n => img_0_cols_V_channel_empty_n,
        if_read => img_0_cols_V_channel_read);

    img_0_data_stream_0_V_U : component FIFO_image_filter_img_0_data_stream_0_V
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_0_data_stream_0_V_U_ap_dummy_ce,
        if_write_ce => img_0_data_stream_0_V_U_ap_dummy_ce,
        if_din => img_0_data_stream_0_V_din,
        if_full_n => img_0_data_stream_0_V_full_n,
        if_write => img_0_data_stream_0_V_write,
        if_dout => img_0_data_stream_0_V_dout,
        if_empty_n => img_0_data_stream_0_V_empty_n,
        if_read => img_0_data_stream_0_V_read);

    img_0_data_stream_1_V_U : component FIFO_image_filter_img_0_data_stream_1_V
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_0_data_stream_1_V_U_ap_dummy_ce,
        if_write_ce => img_0_data_stream_1_V_U_ap_dummy_ce,
        if_din => img_0_data_stream_1_V_din,
        if_full_n => img_0_data_stream_1_V_full_n,
        if_write => img_0_data_stream_1_V_write,
        if_dout => img_0_data_stream_1_V_dout,
        if_empty_n => img_0_data_stream_1_V_empty_n,
        if_read => img_0_data_stream_1_V_read);

    img_1_data_stream_0_V_U : component FIFO_image_filter_img_1_data_stream_0_V
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_1_data_stream_0_V_U_ap_dummy_ce,
        if_write_ce => img_1_data_stream_0_V_U_ap_dummy_ce,
        if_din => img_1_data_stream_0_V_din,
        if_full_n => img_1_data_stream_0_V_full_n,
        if_write => img_1_data_stream_0_V_write,
        if_dout => img_1_data_stream_0_V_dout,
        if_empty_n => img_1_data_stream_0_V_empty_n,
        if_read => img_1_data_stream_0_V_read);

    img_1_data_stream_1_V_U : component FIFO_image_filter_img_1_data_stream_1_V
    port map (
        clk => ap_clk,
        reset => ap_rst_n_inv,
        if_read_ce => img_1_data_stream_1_V_U_ap_dummy_ce,
        if_write_ce => img_1_data_stream_1_V_U_ap_dummy_ce,
        if_din => img_1_data_stream_1_V_din,
        if_full_n => img_1_data_stream_1_V_full_n,
        if_write => img_1_data_stream_1_V_write,
        if_dout => img_1_data_stream_1_V_dout,
        if_empty_n => img_1_data_stream_1_V_empty_n,
        if_read => img_1_data_stream_1_V_read);





    -- ap_reg_procdone_image_filter_AXIvideo2Mat_U0 assign process. --
    ap_reg_procdone_image_filter_AXIvideo2Mat_U0_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_procdone_image_filter_AXIvideo2Mat_U0 <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_sig_hs_done)) then 
                    ap_reg_procdone_image_filter_AXIvideo2Mat_U0 <= ap_const_logic_0;
                elsif ((ap_const_logic_1 = image_filter_AXIvideo2Mat_U0_ap_done)) then 
                    ap_reg_procdone_image_filter_AXIvideo2Mat_U0 <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_procdone_image_filter_Block_Mat_exit45_proc42_U0 assign process. --
    ap_reg_procdone_image_filter_Block_Mat_exit45_proc42_U0_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_procdone_image_filter_Block_Mat_exit45_proc42_U0 <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_sig_hs_done)) then 
                    ap_reg_procdone_image_filter_Block_Mat_exit45_proc42_U0 <= ap_const_logic_0;
                elsif ((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_done)) then 
                    ap_reg_procdone_image_filter_Block_Mat_exit45_proc42_U0 <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_procdone_image_filter_Mat2AXIvideo_U0 assign process. --
    ap_reg_procdone_image_filter_Mat2AXIvideo_U0_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_procdone_image_filter_Mat2AXIvideo_U0 <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_sig_hs_done)) then 
                    ap_reg_procdone_image_filter_Mat2AXIvideo_U0 <= ap_const_logic_0;
                elsif ((ap_const_logic_1 = image_filter_Mat2AXIvideo_U0_ap_done)) then 
                    ap_reg_procdone_image_filter_Mat2AXIvideo_U0 <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_procdone_image_filter_sobel_filter_core_U0 assign process. --
    ap_reg_procdone_image_filter_sobel_filter_core_U0_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_procdone_image_filter_sobel_filter_core_U0 <= ap_const_logic_0;
            else
                if ((ap_const_logic_1 = ap_sig_hs_done)) then 
                    ap_reg_procdone_image_filter_sobel_filter_core_U0 <= ap_const_logic_0;
                elsif ((ap_const_logic_1 = image_filter_sobel_filter_core_U0_ap_done)) then 
                    ap_reg_procdone_image_filter_sobel_filter_core_U0 <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready assign process. --
    ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready <= ap_const_logic_0;
            else
                if (((ap_const_logic_1 = ap_start) and (ap_const_logic_1 = ap_sig_top_allready))) then 
                    ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready <= ap_const_logic_0;
                elsif ((ap_const_logic_1 = image_filter_AXIvideo2Mat_U0_ap_ready)) then 
                    ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready assign process. --
    ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready <= ap_const_logic_0;
            else
                if (((ap_const_logic_1 = ap_start) and (ap_const_logic_1 = ap_sig_top_allready))) then 
                    ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready <= ap_const_logic_0;
                elsif ((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_ready)) then 
                    ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_ready_img_0_cols_V_channel_full_n assign process. --
    ap_reg_ready_img_0_cols_V_channel_full_n_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_ready_img_0_cols_V_channel_full_n <= ap_const_logic_0;
            else
                if (((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_done) and (ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_continue))) then 
                    ap_reg_ready_img_0_cols_V_channel_full_n <= ap_const_logic_0;
                elsif (((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_done) and (ap_const_logic_1 = img_0_cols_V_channel_full_n))) then 
                    ap_reg_ready_img_0_cols_V_channel_full_n <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- ap_reg_ready_img_0_rows_V_channel_full_n assign process. --
    ap_reg_ready_img_0_rows_V_channel_full_n_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                ap_reg_ready_img_0_rows_V_channel_full_n <= ap_const_logic_0;
            else
                if (((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_done) and (ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_continue))) then 
                    ap_reg_ready_img_0_rows_V_channel_full_n <= ap_const_logic_0;
                elsif (((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_done) and (ap_const_logic_1 = img_0_rows_V_channel_full_n))) then 
                    ap_reg_ready_img_0_rows_V_channel_full_n <= ap_const_logic_1;
                end if; 
            end if;
        end if;
    end process;


    -- image_filter_Mat2AXIvideo_U0_ap_start assign process. --
    image_filter_Mat2AXIvideo_U0_ap_start_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                image_filter_Mat2AXIvideo_U0_ap_start <= ap_const_logic_0;
            else
                image_filter_Mat2AXIvideo_U0_ap_start <= ap_const_logic_1;
            end if;
        end if;
    end process;


    -- image_filter_sobel_filter_core_U0_ap_start assign process. --
    image_filter_sobel_filter_core_U0_ap_start_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst_n_inv = '1') then
                image_filter_sobel_filter_core_U0_ap_start <= ap_const_logic_0;
            else
                image_filter_sobel_filter_core_U0_ap_start <= ap_const_logic_1;
            end if;
        end if;
    end process;


    -- ap_CS assign process. --
    ap_CS_assign_proc : process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            ap_CS <= ap_const_logic_0;
        end if;
    end process;
    C_XR0C0_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR0C0_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_din;
    C_XR0C0_channel_read <= image_filter_sobel_filter_core_U0_C_XR0C0_read;
    C_XR0C0_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_write;
    C_XR0C1_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR0C1_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_din;
    C_XR0C1_channel_read <= image_filter_sobel_filter_core_U0_C_XR0C1_read;
    C_XR0C1_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_write;
    C_XR0C2_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR0C2_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_din;
    C_XR0C2_channel_read <= image_filter_sobel_filter_core_U0_C_XR0C2_read;
    C_XR0C2_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_write;
    C_XR1C0_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR1C0_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_din;
    C_XR1C0_channel_read <= image_filter_sobel_filter_core_U0_C_XR1C0_read;
    C_XR1C0_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_write;
    C_XR1C1_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR1C1_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_din;
    C_XR1C1_channel_read <= image_filter_sobel_filter_core_U0_C_XR1C1_read;
    C_XR1C1_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_write;
    C_XR1C2_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR1C2_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_din;
    C_XR1C2_channel_read <= image_filter_sobel_filter_core_U0_C_XR1C2_read;
    C_XR1C2_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_write;
    C_XR2C0_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR2C0_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_din;
    C_XR2C0_channel_read <= image_filter_sobel_filter_core_U0_C_XR2C0_read;
    C_XR2C0_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_write;
    C_XR2C1_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR2C1_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_din;
    C_XR2C1_channel_read <= image_filter_sobel_filter_core_U0_C_XR2C1_read;
    C_XR2C1_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_write;
    C_XR2C2_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_XR2C2_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_din;
    C_XR2C2_channel_read <= image_filter_sobel_filter_core_U0_C_XR2C2_read;
    C_XR2C2_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_write;
    C_YR0C0_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR0C0_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_din;
    C_YR0C0_channel_read <= image_filter_sobel_filter_core_U0_C_YR0C0_read;
    C_YR0C0_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_write;
    C_YR0C1_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR0C1_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_din;
    C_YR0C1_channel_read <= image_filter_sobel_filter_core_U0_C_YR0C1_read;
    C_YR0C1_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_write;
    C_YR0C2_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR0C2_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_din;
    C_YR0C2_channel_read <= image_filter_sobel_filter_core_U0_C_YR0C2_read;
    C_YR0C2_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_write;
    C_YR1C0_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR1C0_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_din;
    C_YR1C0_channel_read <= image_filter_sobel_filter_core_U0_C_YR1C0_read;
    C_YR1C0_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_write;
    C_YR1C1_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR1C1_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_din;
    C_YR1C1_channel_read <= image_filter_sobel_filter_core_U0_C_YR1C1_read;
    C_YR1C1_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_write;
    C_YR1C2_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR1C2_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_din;
    C_YR1C2_channel_read <= image_filter_sobel_filter_core_U0_C_YR1C2_read;
    C_YR1C2_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_write;
    C_YR2C0_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR2C0_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_din;
    C_YR2C0_channel_read <= image_filter_sobel_filter_core_U0_C_YR2C0_read;
    C_YR2C0_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_write;
    C_YR2C1_channel_U_ap_dummy_ce <= ap_const_logic_1;
    C_YR2C1_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_din;
    C_YR2C1_channel_read <= image_filter_sobel_filter_core_U0_C_YR2C1_read;
    C_YR2C1_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_write;

    -- ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_cols_V_channel assign process. --
    ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_cols_V_channel_assign_proc : process(image_filter_Block_Mat_exit45_proc42_U0_ap_done, ap_reg_ready_img_0_cols_V_channel_full_n)
    begin
        if ((ap_const_logic_1 = ap_reg_ready_img_0_cols_V_channel_full_n)) then 
            ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_cols_V_channel <= ap_const_logic_0;
        else 
            ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_cols_V_channel <= image_filter_Block_Mat_exit45_proc42_U0_ap_done;
        end if; 
    end process;


    -- ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_rows_V_channel assign process. --
    ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_rows_V_channel_assign_proc : process(image_filter_Block_Mat_exit45_proc42_U0_ap_done, ap_reg_ready_img_0_rows_V_channel_full_n)
    begin
        if ((ap_const_logic_1 = ap_reg_ready_img_0_rows_V_channel_full_n)) then 
            ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_rows_V_channel <= ap_const_logic_0;
        else 
            ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_rows_V_channel <= image_filter_Block_Mat_exit45_proc42_U0_ap_done;
        end if; 
    end process;

    ap_done <= ap_sig_hs_done;

    -- ap_idle assign process. --
    ap_idle_assign_proc : process(image_filter_Block_Mat_exit45_proc42_U0_ap_idle, image_filter_AXIvideo2Mat_U0_ap_idle, image_filter_sobel_filter_core_U0_ap_idle, image_filter_Mat2AXIvideo_U0_ap_idle, img_0_rows_V_channel_empty_n, img_0_cols_V_channel_empty_n)
    begin
        if (((ap_const_logic_1 = image_filter_Block_Mat_exit45_proc42_U0_ap_idle) and (ap_const_logic_1 = image_filter_AXIvideo2Mat_U0_ap_idle) and (ap_const_logic_1 = image_filter_sobel_filter_core_U0_ap_idle) and (ap_const_logic_1 = image_filter_Mat2AXIvideo_U0_ap_idle) and (ap_const_logic_0 = img_0_rows_V_channel_empty_n) and (ap_const_logic_0 = img_0_cols_V_channel_empty_n))) then 
            ap_idle <= ap_const_logic_1;
        else 
            ap_idle <= ap_const_logic_0;
        end if; 
    end process;

    ap_ready <= ap_sig_top_allready;

    -- ap_rst_n_axilite_clk_inv assign process. --
    ap_rst_n_axilite_clk_inv_assign_proc : process(ap_rst_n_axilite_clk)
    begin
                ap_rst_n_axilite_clk_inv <= not(ap_rst_n_axilite_clk);
    end process;


    -- ap_rst_n_inv assign process. --
    ap_rst_n_inv_assign_proc : process(ap_rst_n)
    begin
                ap_rst_n_inv <= not(ap_rst_n);
    end process;

    ap_sig_hs_continue <= ap_const_logic_1;

    -- ap_sig_hs_done assign process. --
    ap_sig_hs_done_assign_proc : process(image_filter_Mat2AXIvideo_U0_ap_done)
    begin
        if ((ap_const_logic_1 = image_filter_Mat2AXIvideo_U0_ap_done)) then 
            ap_sig_hs_done <= ap_const_logic_1;
        else 
            ap_sig_hs_done <= ap_const_logic_0;
        end if; 
    end process;


    -- ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready assign process. --
    ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready_assign_proc : process(image_filter_AXIvideo2Mat_U0_ap_ready, ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready)
    begin
        if ((ap_const_logic_0 = ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready)) then 
            ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready <= image_filter_AXIvideo2Mat_U0_ap_ready;
        else 
            ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready <= ap_const_logic_1;
        end if; 
    end process;


    -- ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready assign process. --
    ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready_assign_proc : process(image_filter_Block_Mat_exit45_proc42_U0_ap_ready, ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready)
    begin
        if ((ap_const_logic_0 = ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready)) then 
            ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready <= image_filter_Block_Mat_exit45_proc42_U0_ap_ready;
        else 
            ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready <= ap_const_logic_1;
        end if; 
    end process;


    -- ap_sig_ready_img_0_cols_V_channel_full_n assign process. --
    ap_sig_ready_img_0_cols_V_channel_full_n_assign_proc : process(img_0_cols_V_channel_full_n, ap_reg_ready_img_0_cols_V_channel_full_n)
    begin
        if ((ap_const_logic_0 = ap_reg_ready_img_0_cols_V_channel_full_n)) then 
            ap_sig_ready_img_0_cols_V_channel_full_n <= img_0_cols_V_channel_full_n;
        else 
            ap_sig_ready_img_0_cols_V_channel_full_n <= ap_const_logic_1;
        end if; 
    end process;


    -- ap_sig_ready_img_0_rows_V_channel_full_n assign process. --
    ap_sig_ready_img_0_rows_V_channel_full_n_assign_proc : process(img_0_rows_V_channel_full_n, ap_reg_ready_img_0_rows_V_channel_full_n)
    begin
        if ((ap_reg_ready_img_0_rows_V_channel_full_n = ap_const_logic_0)) then 
            ap_sig_ready_img_0_rows_V_channel_full_n <= img_0_rows_V_channel_full_n;
        else 
            ap_sig_ready_img_0_rows_V_channel_full_n <= ap_const_logic_1;
        end if; 
    end process;


    -- ap_sig_start_in_image_filter_AXIvideo2Mat_U0_ap_start assign process. --
    ap_sig_start_in_image_filter_AXIvideo2Mat_U0_ap_start_assign_proc : process(ap_start, ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready)
    begin
        if (((ap_const_logic_1 = ap_start) and (ap_const_logic_0 = ap_reg_ready_image_filter_AXIvideo2Mat_U0_ap_ready))) then 
            ap_sig_start_in_image_filter_AXIvideo2Mat_U0_ap_start <= ap_const_logic_1;
        else 
            ap_sig_start_in_image_filter_AXIvideo2Mat_U0_ap_start <= ap_const_logic_0;
        end if; 
    end process;


    -- ap_sig_start_in_image_filter_Block_Mat_exit45_proc42_U0_ap_start assign process. --
    ap_sig_start_in_image_filter_Block_Mat_exit45_proc42_U0_ap_start_assign_proc : process(ap_start, ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready)
    begin
        if (((ap_const_logic_0 = ap_reg_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready) and (ap_const_logic_1 = ap_start))) then 
            ap_sig_start_in_image_filter_Block_Mat_exit45_proc42_U0_ap_start <= ap_const_logic_1;
        else 
            ap_sig_start_in_image_filter_Block_Mat_exit45_proc42_U0_ap_start <= ap_const_logic_0;
        end if; 
    end process;


    -- ap_sig_top_allready assign process. --
    ap_sig_top_allready_assign_proc : process(ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready, ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready)
    begin
        if (((ap_const_logic_1 = ap_sig_ready_image_filter_Block_Mat_exit45_proc42_U0_ap_ready) and (ap_const_logic_1 = ap_sig_ready_image_filter_AXIvideo2Mat_U0_ap_ready))) then 
            ap_sig_top_allready <= ap_const_logic_1;
        else 
            ap_sig_top_allready <= ap_const_logic_0;
        end if; 
    end process;

    c_high_thresh_channel_U_ap_dummy_ce <= ap_const_logic_1;
    c_high_thresh_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_din;
    c_high_thresh_channel_read <= image_filter_sobel_filter_core_U0_c_high_thresh_read;
    c_high_thresh_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_write;
    c_invert_channel_U_ap_dummy_ce <= ap_const_logic_1;
    c_invert_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_din;
    c_invert_channel_read <= image_filter_sobel_filter_core_U0_c_invert_read;
    c_invert_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_write;
    c_low_thresh_channel_U_ap_dummy_ce <= ap_const_logic_1;
    c_low_thresh_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_din;
    c_low_thresh_channel_read <= image_filter_sobel_filter_core_U0_c_low_thresh_read;
    c_low_thresh_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_write;
    cols_channel_U_ap_dummy_ce <= ap_const_logic_1;
    cols_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_cols_out_din;
    cols_channel_read <= image_filter_sobel_filter_core_U0_cols_read;
    cols_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_cols_out_write;
    image_filter_AXIvideo2Mat_U0_ap_continue <= ap_const_logic_1;
    image_filter_AXIvideo2Mat_U0_ap_start <= (img_0_rows_V_channel_empty_n and img_0_cols_V_channel_empty_n and ap_sig_start_in_image_filter_AXIvideo2Mat_U0_ap_start);
    image_filter_AXIvideo2Mat_U0_img_cols_V_read <= img_0_cols_V_channel_dout;
    image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_full_n <= img_0_data_stream_0_V_full_n;
    image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_full_n <= img_0_data_stream_1_V_full_n;
    image_filter_AXIvideo2Mat_U0_img_rows_V_read <= img_0_rows_V_channel_dout;
    image_filter_AXIvideo2Mat_U0_video_in_TDATA <= video_in_TDATA;
    image_filter_AXIvideo2Mat_U0_video_in_TDEST <= video_in_TDEST;
    image_filter_AXIvideo2Mat_U0_video_in_TID <= video_in_TID;
    image_filter_AXIvideo2Mat_U0_video_in_TKEEP <= video_in_TKEEP;
    image_filter_AXIvideo2Mat_U0_video_in_TLAST <= video_in_TLAST;
    image_filter_AXIvideo2Mat_U0_video_in_TSTRB <= video_in_TSTRB;
    image_filter_AXIvideo2Mat_U0_video_in_TUSER <= video_in_TUSER;
    image_filter_AXIvideo2Mat_U0_video_in_TVALID <= video_in_TVALID;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0 <= C_XR0C0;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR0C0_out_full_n <= C_XR0C0_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1 <= C_XR0C1;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR0C1_out_full_n <= C_XR0C1_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2 <= C_XR0C2;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR0C2_out_full_n <= C_XR0C2_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0 <= C_XR1C0;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR1C0_out_full_n <= C_XR1C0_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1 <= C_XR1C1;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR1C1_out_full_n <= C_XR1C1_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2 <= C_XR1C2;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR1C2_out_full_n <= C_XR1C2_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0 <= C_XR2C0;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR2C0_out_full_n <= C_XR2C0_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1 <= C_XR2C1;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR2C1_out_full_n <= C_XR2C1_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2 <= C_XR2C2;
    image_filter_Block_Mat_exit45_proc42_U0_C_XR2C2_out_full_n <= C_XR2C2_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0 <= C_YR0C0;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR0C0_out_full_n <= C_YR0C0_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1 <= C_YR0C1;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR0C1_out_full_n <= C_YR0C1_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2 <= C_YR0C2;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR0C2_out_full_n <= C_YR0C2_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0 <= C_YR1C0;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR1C0_out_full_n <= C_YR1C0_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1 <= C_YR1C1;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR1C1_out_full_n <= C_YR1C1_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2 <= C_YR1C2;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR1C2_out_full_n <= C_YR1C2_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0 <= C_YR2C0;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR2C0_out_full_n <= C_YR2C0_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1 <= C_YR2C1;
    image_filter_Block_Mat_exit45_proc42_U0_C_YR2C1_out_full_n <= C_YR2C1_channel_full_n;

    -- image_filter_Block_Mat_exit45_proc42_U0_ap_continue assign process. --
    image_filter_Block_Mat_exit45_proc42_U0_ap_continue_assign_proc : process(ap_sig_ready_img_0_rows_V_channel_full_n, ap_sig_ready_img_0_cols_V_channel_full_n)
    begin
        if (((ap_const_logic_1 = ap_sig_ready_img_0_rows_V_channel_full_n) and (ap_const_logic_1 = ap_sig_ready_img_0_cols_V_channel_full_n))) then 
            image_filter_Block_Mat_exit45_proc42_U0_ap_continue <= ap_const_logic_1;
        else 
            image_filter_Block_Mat_exit45_proc42_U0_ap_continue <= ap_const_logic_0;
        end if; 
    end process;

    image_filter_Block_Mat_exit45_proc42_U0_ap_start <= ap_sig_start_in_image_filter_Block_Mat_exit45_proc42_U0_ap_start;
    image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh <= c_high_thresh;
    image_filter_Block_Mat_exit45_proc42_U0_c_high_thresh_out_full_n <= c_high_thresh_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_c_invert <= c_invert;
    image_filter_Block_Mat_exit45_proc42_U0_c_invert_out_full_n <= c_invert_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh <= c_low_thresh;
    image_filter_Block_Mat_exit45_proc42_U0_c_low_thresh_out_full_n <= c_low_thresh_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_cols <= cols;
    image_filter_Block_Mat_exit45_proc42_U0_cols_out_full_n <= cols_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_full_n <= img_1_cols_V_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_full_n <= img_1_rows_V_channel_full_n;
    image_filter_Block_Mat_exit45_proc42_U0_rows <= rows;
    image_filter_Block_Mat_exit45_proc42_U0_rows_out_full_n <= rows_channel_full_n;
    image_filter_CONTROL_BUS_s_axi_U_ap_dummy_ce <= ap_const_logic_1;
    image_filter_Mat2AXIvideo_U0_ap_continue <= ap_sig_hs_continue;
    image_filter_Mat2AXIvideo_U0_img_cols_V_dout <= img_1_cols_V_channel_dout;
    image_filter_Mat2AXIvideo_U0_img_cols_V_empty_n <= img_1_cols_V_channel_empty_n;
    image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_dout <= img_1_data_stream_0_V_dout;
    image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_empty_n <= img_1_data_stream_0_V_empty_n;
    image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_dout <= img_1_data_stream_1_V_dout;
    image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_empty_n <= img_1_data_stream_1_V_empty_n;
    image_filter_Mat2AXIvideo_U0_img_rows_V_dout <= img_1_rows_V_channel_dout;
    image_filter_Mat2AXIvideo_U0_img_rows_V_empty_n <= img_1_rows_V_channel_empty_n;
    image_filter_Mat2AXIvideo_U0_video_out_TREADY <= video_out_TREADY;
    image_filter_sobel_filter_core_U0_C_XR0C0_dout <= C_XR0C0_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR0C0_empty_n <= C_XR0C0_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR0C1_dout <= C_XR0C1_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR0C1_empty_n <= C_XR0C1_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR0C2_dout <= C_XR0C2_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR0C2_empty_n <= C_XR0C2_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR1C0_dout <= C_XR1C0_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR1C0_empty_n <= C_XR1C0_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR1C1_dout <= C_XR1C1_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR1C1_empty_n <= C_XR1C1_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR1C2_dout <= C_XR1C2_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR1C2_empty_n <= C_XR1C2_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR2C0_dout <= C_XR2C0_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR2C0_empty_n <= C_XR2C0_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR2C1_dout <= C_XR2C1_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR2C1_empty_n <= C_XR2C1_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_XR2C2_dout <= C_XR2C2_channel_dout;
    image_filter_sobel_filter_core_U0_C_XR2C2_empty_n <= C_XR2C2_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR0C0_dout <= C_YR0C0_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR0C0_empty_n <= C_YR0C0_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR0C1_dout <= C_YR0C1_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR0C1_empty_n <= C_YR0C1_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR0C2_dout <= C_YR0C2_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR0C2_empty_n <= C_YR0C2_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR1C0_dout <= C_YR1C0_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR1C0_empty_n <= C_YR1C0_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR1C1_dout <= C_YR1C1_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR1C1_empty_n <= C_YR1C1_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR1C2_dout <= C_YR1C2_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR1C2_empty_n <= C_YR1C2_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR2C0_dout <= C_YR2C0_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR2C0_empty_n <= C_YR2C0_channel_empty_n;
    image_filter_sobel_filter_core_U0_C_YR2C1_dout <= C_YR2C1_channel_dout;
    image_filter_sobel_filter_core_U0_C_YR2C1_empty_n <= C_YR2C1_channel_empty_n;
    image_filter_sobel_filter_core_U0_ap_continue <= ap_const_logic_1;
    image_filter_sobel_filter_core_U0_c_high_thresh_dout <= c_high_thresh_channel_dout;
    image_filter_sobel_filter_core_U0_c_high_thresh_empty_n <= c_high_thresh_channel_empty_n;
    image_filter_sobel_filter_core_U0_c_invert_dout <= c_invert_channel_dout;
    image_filter_sobel_filter_core_U0_c_invert_empty_n <= c_invert_channel_empty_n;
    image_filter_sobel_filter_core_U0_c_low_thresh_dout <= c_low_thresh_channel_dout;
    image_filter_sobel_filter_core_U0_c_low_thresh_empty_n <= c_low_thresh_channel_empty_n;
    image_filter_sobel_filter_core_U0_cols_dout <= cols_channel_dout;
    image_filter_sobel_filter_core_U0_cols_empty_n <= cols_channel_empty_n;
    image_filter_sobel_filter_core_U0_dst_data_stream_0_V_full_n <= img_1_data_stream_0_V_full_n;
    image_filter_sobel_filter_core_U0_dst_data_stream_1_V_full_n <= img_1_data_stream_1_V_full_n;
    image_filter_sobel_filter_core_U0_rows_dout <= rows_channel_dout;
    image_filter_sobel_filter_core_U0_rows_empty_n <= rows_channel_empty_n;
    image_filter_sobel_filter_core_U0_src_data_stream_0_V_dout <= img_0_data_stream_0_V_dout;
    image_filter_sobel_filter_core_U0_src_data_stream_0_V_empty_n <= img_0_data_stream_0_V_empty_n;
    image_filter_sobel_filter_core_U0_src_data_stream_1_V_dout <= img_0_data_stream_1_V_dout;
    image_filter_sobel_filter_core_U0_src_data_stream_1_V_empty_n <= img_0_data_stream_1_V_empty_n;
    img_0_cols_V_channel_U_ap_dummy_ce <= ap_const_logic_1;
    img_0_cols_V_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_ap_return_1;
    img_0_cols_V_channel_read <= image_filter_AXIvideo2Mat_U0_ap_ready;
    img_0_cols_V_channel_write <= ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_cols_V_channel;
    img_0_data_stream_0_V_U_ap_dummy_ce <= ap_const_logic_1;
    img_0_data_stream_0_V_din <= image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_din;
    img_0_data_stream_0_V_read <= image_filter_sobel_filter_core_U0_src_data_stream_0_V_read;
    img_0_data_stream_0_V_write <= image_filter_AXIvideo2Mat_U0_img_data_stream_0_V_write;
    img_0_data_stream_1_V_U_ap_dummy_ce <= ap_const_logic_1;
    img_0_data_stream_1_V_din <= image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_din;
    img_0_data_stream_1_V_read <= image_filter_sobel_filter_core_U0_src_data_stream_1_V_read;
    img_0_data_stream_1_V_write <= image_filter_AXIvideo2Mat_U0_img_data_stream_1_V_write;
    img_0_rows_V_channel_U_ap_dummy_ce <= ap_const_logic_1;
    img_0_rows_V_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_ap_return_0;
    img_0_rows_V_channel_read <= image_filter_AXIvideo2Mat_U0_ap_ready;
    img_0_rows_V_channel_write <= ap_chn_write_image_filter_Block_Mat_exit45_proc42_U0_img_0_rows_V_channel;
    img_1_cols_V_channel_U_ap_dummy_ce <= ap_const_logic_1;
    img_1_cols_V_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_din;
    img_1_cols_V_channel_read <= image_filter_Mat2AXIvideo_U0_img_cols_V_read;
    img_1_cols_V_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_img_1_cols_V_out_write;
    img_1_data_stream_0_V_U_ap_dummy_ce <= ap_const_logic_1;
    img_1_data_stream_0_V_din <= image_filter_sobel_filter_core_U0_dst_data_stream_0_V_din;
    img_1_data_stream_0_V_read <= image_filter_Mat2AXIvideo_U0_img_data_stream_0_V_read;
    img_1_data_stream_0_V_write <= image_filter_sobel_filter_core_U0_dst_data_stream_0_V_write;
    img_1_data_stream_1_V_U_ap_dummy_ce <= ap_const_logic_1;
    img_1_data_stream_1_V_din <= image_filter_sobel_filter_core_U0_dst_data_stream_1_V_din;
    img_1_data_stream_1_V_read <= image_filter_Mat2AXIvideo_U0_img_data_stream_1_V_read;
    img_1_data_stream_1_V_write <= image_filter_sobel_filter_core_U0_dst_data_stream_1_V_write;
    img_1_rows_V_channel_U_ap_dummy_ce <= ap_const_logic_1;
    img_1_rows_V_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_din;
    img_1_rows_V_channel_read <= image_filter_Mat2AXIvideo_U0_img_rows_V_read;
    img_1_rows_V_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_img_1_rows_V_out_write;
    rows_channel_U_ap_dummy_ce <= ap_const_logic_1;
    rows_channel_din <= image_filter_Block_Mat_exit45_proc42_U0_rows_out_din;
    rows_channel_read <= image_filter_sobel_filter_core_U0_rows_read;
    rows_channel_write <= image_filter_Block_Mat_exit45_proc42_U0_rows_out_write;
    video_in_TREADY <= image_filter_AXIvideo2Mat_U0_video_in_TREADY;
    video_out_TDATA <= image_filter_Mat2AXIvideo_U0_video_out_TDATA;
    video_out_TDEST <= image_filter_Mat2AXIvideo_U0_video_out_TDEST;
    video_out_TID <= image_filter_Mat2AXIvideo_U0_video_out_TID;
    video_out_TKEEP <= image_filter_Mat2AXIvideo_U0_video_out_TKEEP;
    video_out_TLAST <= image_filter_Mat2AXIvideo_U0_video_out_TLAST;
    video_out_TSTRB <= image_filter_Mat2AXIvideo_U0_video_out_TSTRB;
    video_out_TUSER <= image_filter_Mat2AXIvideo_U0_video_out_TUSER;
    video_out_TVALID <= image_filter_Mat2AXIvideo_U0_video_out_TVALID;
end behav;
